<?php
session_start();
include ('./lib/common.php');
global $loginAccueil,$motPasseAccueil;

// Initialisation des variables
$service = initialisationVariableFormulaire('service');
$login = initialisationVariableFormulaire('login');
$password = initialisationVariableFormulaire('password');
$type = initialisationVariableFormulaire('type');
$nom = initialisationVariableFormulaire('nom');
$prenom = initialisationVariableFormulaire('prenom');
$rc = initialisationVariableFormulaire('rc');
$loginAdmin = initialisationVariableFormulaire('loginAdmin');
$passwordAdmin = initialisationVariableFormulaire('passwordAdmin');
$description = initialisationVariableFormulaire('description');

//Conection à Open Ldap
if(!(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '')){
    connectionLdap();
}

// Authentification
if(!(isset($_SESSION['estUtilisateur']) && $_SESSION['estUtilisateur'] > 0)){
    if($login != '' && $password != '' && $login != $loginAccueil && $password != $motPasseAccueil){
        verificationAuthentification($login,$password);
    }
}

// Traitement des services
$message='';
if($service == 'd'){
    deconnectionUtilisateur();
}
else if($service == 'cmpAction'){
    $changementPassword = initialisationVariableFormulaire('changementPassword');
    $confirmationChangementPassword = initialisationVariableFormulaire('confirmationChangementPassword');
    
    $message = changementMotPasseAction($_SESSION['dn'],$changementPassword,$confirmationChangementPassword);    
    $service = 'cmp';
}
else if($service == 'mmpee'){
    $dn = initialisationVariableFormulaire('dn');
    $mp = initialisationVariableFormulaire('mp');
    
    $message = changementMotPasseAction($dn,$mp,$mp);
    print $message;
    exit;
}
else if($service == 'aecAction'){
    $message = creationClasseEnseignantAction($type,$nom,$prenom);
    $service = 'aec';
}
else if($service == 'deAction'){
    desaffecterEnseignantAction();
    exit;
}
else if($service == 'sedAction'){
    suppressionCompteAction();
    exit;
}
else if($service == 'pedAction'){
    migrationEnseignantDirecteurAction();
    exit;
}
else if($service == 'ddAction'){
    destitutionDirecteurAction();
    exit;
}
else if($service == 'cgtAction'){
    $message = creationGroupeThematiqueAction($login,$description);
    $service = 'cgt';
}
else if($service == 'alpalisAction'){
    $message = creationCompteAdminProxyAction($type,$nom,$prenom,$loginAdmin,$passwordAdmin);
    $service = initialisationVariableFormulaire('serviceAppel');
}
else if($service == 'alpalisSupression'){
    $message = suppressionCompteAdminProxyAction();
}
else if($service == 'aaeAction'){
    affectationEnseignantGroupe();
    exit;
}
else if($service == 'ggtAction'){
    affectationUtilisateurGroupeThematique();
    exit;
}
else if($service == 'ggtActionSuppressionGroupeThematique'){
    suppressionGroupeThematique();
    exit;
}
else if($service == 'detailLdap'){
    getDetailLdap();
    exit;
}
?>

<!DOCTYPE HTML>
<html lang="fr">
    <head>
        <?php
        initialisationHead($service,$rc,$loginAdmin,$passwordAdmin);
        ?>
    </head>
    <body>
        <?php
        affichageBandeau();
        ?>
        <center>
            <table border="0" width="99%">
        <?php
        if(isset($_SESSION['estUtilisateur']) && $_SESSION['estUtilisateur'] > 0){
            ?>
                <tr>
                    <td valign="top" width="220">
                        <?php
                        afficheTypeMenu($service);
                        ?>
                    </td>
                    <td valign="top" align="center">
                        <table border="0" width="98%">
                            <tr>
                                <td align="center">
                                    <?php
                                    if($service == 'cmp'){
                                        changementMotPasse($message);
                                    }
                                    else if($service == 'cmpce'){
                                        changementMotPasseClasseEnseignant($rc);
                                    }
                                    else if($service == 'aec'){
                                        creationClasseEnseignant($type,$nom,$prenom,$message);
                                    }
                                    else if($service == 'de'){
                                        desaffecterEnseignant($rc);
                                    }
                                    else if($service == 'aae'){
                                        creationEnseignantEcole($rc);
                                    }
                                    else if($service == 'sed'){
                                        suppressionEnseignantDirecteur($rc);
                                    }
                                    else if($service == 'ped'){
                                        migrationEnseignantDirecteur($rc);
                                    }
                                    else if($service == 'cgt'){
                                        creationGroupeThematique($message,$login,$description);
                                    }
                                    else if($service == 'ggt'){
                                        gestionGroupeThematique($rc);
                                    }
                                    else if($service == 'alp'){
                                        creationCompteAdminProxy(0,$message,$service,$nom,$prenom,$loginAdmin,$passwordAdmin);
                                    }
                                    else if($service == 'alis'){
                                        creationCompteAdminProxy(1,$message,$service,$nom,$prenom,$loginAdmin,$passwordAdmin);
                                    }
                                    else if($service == 'cldap'){
                                        affichageConsoleLdap($rc);
                                    }
                                    else{
                                        affichagePageConnecte();
                                    }
                                    ?>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            <?php
        }
        else{
            formulaireConnection($login,$password,$service);
        }
        ?>
            </table>
        </center>
    </body>
</html>
