/***********************************************************/
/*       Fonction permettant de créer un objet Ajax        */
/***********************************************************/
function getXhr(){

var xhr = null; 
if(window.XMLHttpRequest){
    // Firefox et autres
    xhr = new XMLHttpRequest(); 
}
else if(window.ActiveXObject){
    // Internet Explorer 
    try{
        xhr = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch(e){
        xhr = new ActiveXObject("Microsoft.XMLHTTP");
    }
}
else{
    // XMLHttpRequest non supporté par le navigateur 
    alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest...");
    xhr = false; 
}

return xhr;
}


/**************************************************************************************/
/* Fonction permettant de désactiver l'autocompletion navigateur dans les champ text  */
/**************************************************************************************/
function autoCompleteMode(id){
    data = document.getElementById(id);
    if(data != undefined){
        data.setAttribute('autocomplete','off');
    }
}


/***************************************************************************************/
/* Fonction permettant de vider un champ dans un formulaire au démarrage de la session */
/***************************************************************************************/
function vidageChamp(id){
    data = document.getElementById(id);
    if(data != undefined){
        data.value='';
    }
}


/**********************************************************************************/
/* Fonction permettant de modifier un mot de passe pour un enseignant ou un élève */
/**********************************************************************************/
function modificationMotPasseEE(dn,idMotPasse,idMessage,classMessage){
    
var motPasse = document.getElementById(idMotPasse);
if(motPasse != undefined){
    motPasse = motPasse.value;
}
else{
    motPasse='';
}

tabMessage = document.getElementsByClassName(classMessage);
for(var i=0;i<tabMessage.length;i++){
    tabMessage[i].innerHTML = '';
}

// Vérification du mot de passe avant envoie au serveur
var bool = valideChangementMotPasseAction(motPasse,motPasse,idMessage);
if(bool == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){            
            var message = document.getElementById(idMessage);
            if(message != undefined){
                message.innerHTML = xhr.responseText;
            }
        }
    }

    var url = baseURL+'index.php?service=mmpee&dn='+encodeURIComponent(dn)+'&mp='+encodeURIComponent(motPasse);
    var date = new Date();
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/****************************************************/
/* Fonction permettant de désaffecter un enseignant */
/****************************************************/
function desaffecterEnseignant(uid,objet,idTableau){

var check = confirm("Voulez-vous désaffecter cet enseignant ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            suppressionLigneJquery(objet,idTableau);
        }
    }
    
    var host = document.getElementById('host');
    if(host != undefined){
        host = host.value;
    }

    var url = baseURL+'index.php?service=deAction&uid='+uid+'&host='+host;
    var date = new Date();
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/****************************************************/
/* Fonction permettant de désaffecter un enseignant */
/****************************************************/
function suppressionCompte(dn,objet,idTableau){

var check = confirm("Voulez-vous supprimer ce compte ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            suppressionLigneJquery(objet,idTableau);
        }
    }

    var url = baseURL+'index.php?service=sedAction&dn='+encodeURIComponent(dn);
    var date = new Date();
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/***********************************************************************/
/* Fonction permettant de supprimer une ligne d'un tableau avec Jquery */
/***********************************************************************/
function suppressionLigneJquery(ligne,idTableau){    
    var row = $(ligne).closest('tr');
    $('#'+idTableau).dataTable().fnDeleteRow(row[0]); 
}


/************************************************************/
/* Fonction permettant de migrer un enseignatn en directeur */
/************************************************************/
function migrationEnseignantDirecteur(uid,objet,idTableau){

var check = confirm("Voulez-vous passer cet enseignant en directeur ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            suppressionLigneJquery(objet,idTableau);
        }
    }
    
    var affectationDirecteur = document.getElementById('affectationDirecteur');
    if(affectationDirecteur != undefined){
        affectationDirecteur = affectationDirecteur.value;
    }

    var url = baseURL+'index.php?service=pedAction&uid='+encodeURIComponent(uid)+'&affectationDirecteur='+affectationDirecteur;
    var date = new Date();
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/**********************************************************************************************************/
/* Fonction permettant de vérifier que les champs du formulaire sont correctement rempli avant validation */
/**********************************************************************************************************/
function valideChangementMotPasse(objet,idMessage){

var motPasse = objet.changementPassword.value;
var motPasseConfirmation = objet.confirmationChangementPassword.value;

var bool = valideChangementMotPasseAction(motPasse,motPasseConfirmation,idMessage);

return bool;
}


/***********************************************************************************************/
/* Fonction permettant de vérifier que 2 mots de passe sont égaux et conforme avant validation */
/***********************************************************************************************/
function valideChangementMotPasseAction(motPasse,motPasseConfirmation,idMessage){

var bool = false;
var regExp = new RegExp("[^0-9a-z]","i");
var messageAlerte = document.getElementById(idMessage);

if(motPasse == '' || motPasseConfirmation == ''){
    if(messageAlerte != undefined){
        messageAlerte.innerHTML = '<div class="alert alert-block alert-danger"><h4>Erreur !</h4>Veuillez sp\351cifier tous les champs SVP</div>';
        messageAlerte.style.display = '';
    }
}
else if(motPasse.length < 4 || motPasseConfirmation.length < 4){
    if(messageAlerte != undefined){
        messageAlerte.innerHTML = '<div class="alert alert-block alert-danger"><h4>Erreur !</h4>Veuillez sp\351cifier un mot de passe de 4 caract\350res au minimum</div>';
        messageAlerte.style.display = '';
    }
}
else if(motPasse != motPasseConfirmation){
    if(messageAlerte != undefined){
        messageAlerte.innerHTML = '<div class="alert alert-block alert-danger"><h4>Erreur !</h4>Veuillez sp\351cifier 2 fois le m\352me mot de passe SVP</div>';
        messageAlerte.style.display = '';
    }
}
else if(regExp.test(motPasse)){
    if(messageAlerte != undefined){
        messageAlerte.innerHTML = '<div class="alert alert-block alert-danger"><h4>Erreur !</h4>Veuillez n\'utiliser que des chiffres et/ou des lettres SVP</div>';
        messageAlerte.style.display = '';
    }
}
else{
    bool = true;
}

return bool;
}


/*****************************************************************************************/
/* Fonction permettant de vérifier que le champ mot de passe soit correctement renseigné */
/*****************************************************************************************/
function valideCreationMotPasseAdmin(objet){

var nom = objet.nom.value;
var prenom = objet.prenom.value;
var login = objet.login.value;
var motPasse = objet.password.value;
var bool = false;

if(nom == '' || prenom == '' || login == ''){
    alert('Veuillez spécifier tous les champs SVP');
}
else{
    bool = valideChangementMotPasseAction(motPasse,motPasse,'');
}

return bool;
}


/************************************************************************/
/* Fonction permettant d'ajouter à un groupe d'enseignant un enseignant */
/************************************************************************/
function nouvelleAffectation(uid,ecole){

nomEcole = document.getElementById(ecole);
if(nomEcole != undefined){
    nomEcole = nomEcole.value;
}

var xhr = getXhr();
// On défini ce qu'on va faire quand on aura la réponse
xhr.onreadystatechange = function() {
    // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
    if(xhr.readyState == 4 && xhr.status == 200){
        window.location.href = baseURL+'index.php?service=aae';
    }
}

var url = baseURL+'index.php?service=aaeAction&uid='+encodeURIComponent(uid)+'&nomEcole='+encodeURIComponent(nomEcole)+'&typeAction=0';
var date = new Date();
xhr.open("GET",url+'&'+date.getTime(),true);    
xhr.send(null);
}


/***************************************************************************/
/* Fonction permettant de supprimer d'un groupe d'enseignant un enseignant */
/***************************************************************************/
function suppressionAffectation(uid,ecole){

var check = confirm("Voulez-vous supprimer l'affectation de cet enseignant ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            window.location.href = baseURL+'index.php?service=aae';
        }
    }

    var url = baseURL+'index.php?service=aaeAction&uid='+encodeURIComponent(uid)+'&nomEcole='+encodeURIComponent(ecole)+'&typeAction=1';
    var date = new Date();    
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/************************************************************************/
/* Fonction permettant d'ajouter une personne dans un groupe thématique */
/************************************************************************/
function affecterUtilisateurGroupeThematique(dnGroupe,idListePersonne){

var check = confirm("Voulez-vous ajouter cet utilisateur dans ce groupe thématique ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            window.location.href = baseURL+'index.php?service=ggt';
        }
    }
    
    uidUtilisateur = document.getElementById(idListePersonne);
    if(uidUtilisateur != undefined){
        var url = baseURL+'index.php?service=ggtAction&dnGroupe='+encodeURIComponent(dnGroupe)+'&uid='+encodeURIComponent(uidUtilisateur.value)+'&type=0';
        var date = new Date();    
        xhr.open("GET",url+'&'+date.getTime(),true);    
        xhr.send(null);
    }
}
}


/***************************************************************************/
/* Fonction permettant de supprimer une personne d'un un groupe thématique */
/***************************************************************************/
function suppressionMembreGroupeThematique(dnGroupe,uid){

var check = confirm("Voulez-vous supprimer cet utilisateur de ce groupe thématique ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            window.location.href = baseURL+'index.php?service=ggt';
        }
    }
    
    var url = baseURL+'index.php?service=ggtAction&dnGroupe='+encodeURIComponent(dnGroupe)+'&uid='+encodeURIComponent(uid)+'&type=1';
    var date = new Date();    
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/*********************************************************/
/* Fonction permettant de supprimer un groupe thématique */
/**********************************************************/
function suppressionGroupeThematique(dnGroupe,gidNumber){

var check = confirm("Voulez-vous supprimer ce groupe thématique ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            window.location.href = baseURL+'index.php?service=ggt';
        }
    }
    
    var url = baseURL+'index.php?service=ggtActionSuppressionGroupeThematique&dnGroupe='+encodeURIComponent(dnGroupe)+'&gidNumber='+gidNumber;
    var date = new Date();    
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}



/*************************************************************/
/* Fonction permettant d'afficher masquer le contenu du Ldap */
/*************************************************************/
function consoleLdap(objet,dn){
    
objet = objet.firstChild;        
while(objet.nodeName != 'IMG'){
    objet = objet.nextSibling;
}

if(objet != null){
    var tabImage = objet.src.match(/plus\.gif/);
    if(tabImage == null){
        objet.src = './image/plus.gif';    
        var trs = document.getElementById("affichageResultat").getElementsByTagName("tr");
        for(var i=0;i<trs.length;i++){
            var regex = new RegExp(dn+'$','g');
            if(trs[i].className.match(regex)){
                trs[i].style.display = 'none';
            }
        }
    }
    else{
        objet.src = './image/moins.gif';
        var tabDN = document.getElementsByClassName(dn);
        for(var i=0;i<tabDN.length;i++){
            tabDN[i].style.display = '';
        }
    }    
}
}


/************************************************************/
/* Fonction permettant d'afficher le détail d'un objet ldap */
/************************************************************/
function afficheDetailLdap(dn,idDetail){

data = document.getElementById(idDetail);
if(data != undefined){
    data.style.paddingTop = '300px';
    data.innerHTML='<table class="aligncenter" style="border:0px;" width="100%"><tr><td align="center"><table class="aligncenter" style="border:0px;"><tr><td><span>Chargement</span></td><td>&nbsp;<img src="'+baseURL+'image/chargement.gif" border="0" width="30" height="30"></td></tr></table></td></tr></table>';
}

var xhr = getXhr();
// On défini ce qu'on va faire quand on aura la réponse
xhr.onreadystatechange = function() {
    // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
    if(xhr.readyState == 4 && xhr.status == 200){
        if(data != undefined){
            data.style.paddingTop = '0px';
            data.innerHTML = xhr.responseText;
        }
    }
}

var url = baseURL+'index.php?service=detailLdap&dn='+encodeURIComponent(dn);
var date = new Date();    
xhr.open("GET",url+'&'+date.getTime(),true);    
xhr.send(null);
}


/*********************************************************************************************************************/
/*  Fonction permettant de vider le texte d'un champ quand on click dessus et quand le message d'accueil est affiché */
/*********************************************************************************************************************/
function changementTexteForm(objet,messageOrigine){

if(objet.value == messageOrigine){
    objet.value = '';
}

objet.style.color = '#000000';
}


/**************************************************************/
/*  Fonction permettant de réinitialiser la couleur d'origine */
/**************************************************************/
function changeColorForm(objet,color){

objet.style.color = color;
}


/*****************************************************/
/*  Fonction permettant d'afficher une bulle d'aide  */
/*****************************************************/
function AffBulle(text,tailleBulle,decallageBulleXPrivate,decallageBulleYPrivate,typeFrame){
    if(tailleBulle == '' || tailleBulle == undefined){
        tailleBulle = 200;
    }

    if(typeof(decallageBulleX) != 'undefined'){
        decallageBulleX = decallageBulleXPrivate;
    }
    
    if(typeof(decallageBulleY) != 'undefined'){
        decallageBulleY = decallageBulleYPrivate;
    }
    
    var reg=new RegExp("###","g");
    var text = text.replace(reg,"'");
    
    var reg=new RegExp("%%%","g");
    var text = text.replace(reg,'"');

    if(afficheBulle == false){
        var finalPosX = posX - xOffset;
        if(finalPosX < 0){
            finalPosX = 0;
        }
  
        GetId(nomBulle).style.visibility = 'hidden';
        GetId(nomBulle).style.top = posY+yOffset;
        //GetId(nomBulle).style.width = tailleBulle+'px';
        
        if(typeFrame == 1){
            GetId(nomBulle).style.left = parseInt(finalPosX - 300)+'px';
            GetId(nomBulle).innerHTML = '<table style="border:1px;padding:0px;margin:0px;" cellpadding="0" cellspacing="0"><tr><td style="padding:0px;margin:0px;"><table style="border:1px;padding:0px;margin:0px;" cellpadding="0" cellspacing="0"><tr><td style="padding:0px;margin:0px;"></td><td><img src="'+baseURL+'chargement.gif" border="0" width="25" height="25"></td></tr></table></td></tr></table>';
    
            var xhr = getXhr();
            // On défini ce qu'on va faire quand on aura la réponse
            xhr.onreadystatechange = function() {
                // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
                if(xhr.readyState == 4 && xhr.status == 200){                    
                    GetId(nomBulle).innerHTML = xhr.responseText;
                    GetId(nomBulle).style.left = parseInt(finalPosX - 300)+'px';
                }
            }
            
            var date=new Date();
            var requete=baseURL+'result_annuaire.php?serviceCarte='+text+'&'+date.getTime();
            xhr.open("GET",requete,true);
            xhr.send(null);
        }
        else{
            GetId(nomBulle).style.left = finalPosX;
            GetId(nomBulle).innerHTML = text;
        }

        GetId(nomBulle).style.visibility = 'visible';
        afficheBulle = true;
    }
}


/****************************************************/
/*  Fonction permettant de cacher une bulle d'aide  */
/****************************************************/
function HideBulle() {
    if(afficheBulle == true) {
        GetId(nomBulle).style.visibility = 'hidden';
        afficheBulle = false;
    }
}


/**************************************************************/
/*  Fonction permettant d'obtenir l'objet de la bulle d'aide  */
/**************************************************************/
function GetId(id){
    return document.getElementById(id);
}


/********************************************************************/
/*  Fonction permettant de calculer la position d'une bulle d'aide  */
/********************************************************************/
function move(e) {
    if(afficheBulle) {
        var decallageBulleXPrivate=0;
        if(typeof(decallageBulleX) != 'undefined'){
            decallageBulleXPrivate = decallageBulleX;
        }
        
        var decallageBulleYPrivate=0;
        if(typeof(decallageBulleY) != 'undefined'){
            decallageBulleYPrivate = decallageBulleY;
        }
        
        if(navigator.appName!="Microsoft Internet Explorer") {
            GetId(nomBulle).style.left=parseInt(e.pageX) + 5 + parseInt(decallageBulleXPrivate) + 'px';
            GetId(nomBulle).style.top=parseInt(e.pageY) + 10 + parseInt(decallageBulleYPrivate) + 'px';
            posX = e.pageX;
            posY = e.pageY;
        }
        else {
            if(document.documentElement.clientWidth>0) {
                GetId(nomBulle).style.left = 20 + parseInt(decallageBulleXPrivate) + parseInt(event.x) + parseInt(document.documentElement.scrollLeft) + 'px';
                GetId(nomBulle).style.top  = 10 + parseInt(decallageBulleYPrivate) + parseInt(event.y) + parseInt(document.documentElement.scrollTop) + 'px';
            } 
            else {
                GetId(nomBulle).style.left = 20 + parseInt(decallageBulleXPrivate) + parseInt(event.x) + parseInt(document.body.scrollLeft) + 'px';
                GetId(nomBulle).style.top  = 10 + parseInt(decallageBulleYPrivate) + parseInt(event.y) + parseInt(document.body.scrollTop) + 'px';
            }
            
            posX = event.x;
            posY = event.y;
        }
    }
}


/******************************************************/
/* Fonction permettant de supprimer un administrateur */
/******************************************************/
function suppressionAdmin(dn,type,uid){

var check = confirm("Voulez-vous supprimer ce compte administrateur ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            var serviceRedirection='';
            if(type == 0){
                serviceRedirection = 'alp';
            }
            else{
                serviceRedirection = 'alis';
            }
            
            window.location.href = baseURL+'index.php?service='+serviceRedirection;
        }
    }
    
    var url = baseURL+'index.php?service=alpalisSupression&dn='+encodeURIComponent(dn)+'&type='+type+'&uid='+encodeURIComponent(uid);
    var date = new Date();    
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/*************************************************/
/* Fonction permettant de destituer un directeur */
/*************************************************/
function destituerDirecteur(uid,objet,idTableau){

var check = confirm("Voulez-vous passer ce directeur en enseignant ?");

if(check == true){
    var xhr = getXhr();
    // On défini ce qu'on va faire quand on aura la réponse
    xhr.onreadystatechange = function() {
        // On ne fait quelque chose que si on a tout reçu et que le serveur est ok
        if(xhr.readyState == 4 && xhr.status == 200){
            suppressionLigneJquery(objet,idTableau);
        }
    }

    var url = baseURL+'index.php?service=ddAction&uid='+encodeURIComponent(uid);
    var date = new Date();
    xhr.open("GET",url+'&'+date.getTime(),true);    
    xhr.send(null);
}
}


/*********************************************************************************************************/
/* Fonction permettant de demander une confirmation lors de la création d'un nouveau compte d'enseignant */
/*********************************************************************************************************/
function confirmationAjoutEnseignant(){

return confirm("Voulez-vous ajouter cet enseignant ?");
}

