<?php
// Connexion à Open Ldap
$ldapHote = 'serveurldap';
$ldapLogin = 'loginldap';
$ldapPassword = 'motdepasse';
$ecoleCourant = 'baseldap';

$colorRouge = '#FC3030';

// Déclaration des variables d'accueil pour l'authentification
$loginAccueil = 'Identifiant';
$motPasseAccueil = 'Mot de Passe';

// Déclaration du nombre de ligne maximum affichée dans un tableau
$nbMaxLigneTab = 10;

/***************************************************/
/* Fonction permettant de se connecter à open ldap */
/***************************************************/
function connectionLdap(){

global $ldapHote,$ldapLogin,$ldapPassword;

$ldapconn = @ldap_connect($ldapHote);
if($ldapconn != ''){
    $_SESSION['connLdap'] = $ldapconn;
    
    ldap_set_option($ldapconn,LDAP_OPT_PROTOCOL_VERSION,3);
    
    // Connexion au serveur LDAP
    $ldapbind = @ldap_bind($ldapconn,$ldapLogin,$ldapPassword);
    if($ldapbind != ''){
        $_SESSION['ldapbind'] = $ldapbind;
    }
}

return $ldapconn;
}


/****************************************************************/
/* Fonction permettant de trier le tableau de toutes les écoles */
/****************************************************************/
function triEcole($a,$b){
    return ($a['nom'] < $b['nom']) ? -1 : 1;
}


/*************************************************************************/
/* Fonction permettant de trier le tableau des enseignants et directeurs */
/*************************************************************************/
function triEnseignantDirecteur($a,$b){
    if($a['type'] == $b['type']){
        return ($a['sn'] < $b['sn']) ? 1 : -1;
    }
    else{
        return ($a['type'] < $b['type']) ? -1 : 1;
    }
}


/*********************************************/
/* Fonction permettant de trier l'arbre Ldap */
/*********************************************/
function triLdap($a,$b){
    return ($a['dnInverse'] > $b['dnInverse']) ? -1 : 1;
}


/***************************************************************/
/* Fonction permettant de trier un tableau sur les uid / login */
/***************************************************************/
function triUid($a,$b){
    return ($a['uid'] < $b['uid']) ? -1 : 1;
}


/********************************************************************************/
/* Fonction permettant de vérifier l'authentification de l'utilisateur courant  */
/********************************************************************************/
function verificationAuthentification($login,$password){

global $ecoleCourant;
$_SESSION['estUtilisateur'] = -1;

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && isset($_SESSION['ldapbind']) && $_SESSION['ldapbind'] != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }    
    
    $guetteurIdentifiant = 0;
    $filter = "(&(objectClass=person)(uid=$login))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $userPassword = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'userPassword'));
                $passwordValide = verificationMotPasseLdap($password,$userPassword);
                $guetteurIdentifiant = 1;
                
                if($passwordValide){
                    $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                    $uid = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
                    $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                    $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                    
                    if($gidNumber == 8000){
                        //Utilisateur Admin
                        $_SESSION['estUtilisateur'] = 4;
                    }
                    else if($gidNumber == 8100){
                        //Utilisateur Proximité
                        $_SESSION['estUtilisateur'] = 3;
                    }
                    else if($gidNumber == 9000){
                        // Utilisateur Directeur
                        $_SESSION['estUtilisateur'] = 2;
                    }
                    else if(estEnseignant($uid)){
                        //Utilisateur Enseignant
                        $_SESSION['estUtilisateur'] = 1;
                    }
                    else{
                        // Utilisateur Inconnu
                        $_SESSION['estUtilisateur'] = 0;
                    }

                    $_SESSION['dn'] = $dnCourant;
                    $_SESSION['uid'] = $uid;
                    $_SESSION['cn'] = $cn;
                }
                else{
                    // Mot de passe incorrect
                    $_SESSION['estUtilisateur'] = 0;
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    if($guetteurIdentifiant != 1){
        // Identifiants incorrects
        $_SESSION['estUtilisateur'] = 0;
    }
}
}


/****************************************************************************************/
/* Fonction permettant de récupérer la valeur du tableau résultat avec un getValue Ladp */
/****************************************************************************************/
function getInfoLdapEntry($tabInfo){

$data='';
if(isset($tabInfo) && isset($tabInfo[0])){
    $data = $tabInfo[0];
}

return $data;
}


/********************************************************************************************/
/* Fonction permettant de récupérer la valeur d'une variable passé soit en POST soit en GET */
/********************************************************************************************/
function initialisationVariableFormulaire($variable){

$data='';
if(isset($_POST[$variable])){
    $data = $_POST[$variable];
}
else if(isset($_GET[$variable])){
    $data = $_GET[$variable];
}

return $data;
}


/*****************************************************/
/* Fonction permettant à un utilisateur de se loguer */
/*****************************************************/
function formulaireConnection($login,$password,$service){

global $loginAccueil,$motPasseAccueil;

if($login == ''){
    $login = $loginAccueil;
    
}
if($password == ''){
    $password = $motPasseAccueil;
}

?>
<tr>
    <td align="center" width="100%" colspan="2">
        <form name="connection" method="post" action="index.php" class="form-inline well">
            <table border="0">
                <tr>
                    <td>
                        <div class="form-group input-group">
                            <span class="input-group-addon">
                                <img src="/image/login.png" border="0">
                            </span>
                            <INPUT class="colorTexteGris form-control" type="text" size="30" name="login" value="<?php echo $login?>" onFocus="changementTexteForm(this,'<?php echo $loginAccueil?>');" onBlur="changeColorForm(this,'#aaaaaa');">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td>
                        <div class="form-group input-group">
                            <span class="input-group-addon">
                                <img src="/image/cadenas.png" border="0">
                            </span>
                            <INPUT class="colorTexteGris form-control" type="password" size="30" name="password" value="<?php echo $password?>" onFocus="changementTexteForm(this,'<?php echo $motPasseAccueil?>');" onBlur="changeColorForm(this,'#aaaaaa');">
                        </div>
                    </td>
                </tr>
                <tr>
                    <td align="center">
                        <INPUT TYPE="hidden" name="service" VALUE="lg">
                        <INPUT TYPE="submit" id="validation" NAME="validation" VALUE="Connexion" onmouseover="changeColorForm(this,'#000000');" onmouseout="changeColorForm(this,'#ffffff');" class="btn btn-primary">
                    </td>
                </tr>
                <tr>
                    <td>
                        <?php
                        if(($login == '' && $password == '') || ($login == $loginAccueil && $password == $motPasseAccueil) && $service == 'lg'){
                            ?>
                            <br>
                            <div class="alert alert-block alert-warning">
                                <h4>Attention !</h4>
                                Veuillez sp&eacute;cifier vos identifiants SVP
                            </div>
                            <?php
                        }
                        else if(isset($_SESSION['estUtilisateur']) && $_SESSION['estUtilisateur'] == 0){
                            ?>
                            <br>
                            <div class="alert alert-block alert-danger">
                                <h4>Erreur !</h4>
                                Identifiants incorrects
                            </div>
                            <?php
                        }
                        ?>
                    </td>
                </tr>
            </table>
        </form>
    </td>
</tr>
<?php
}


/********************************************************************************/
/* Fonction permettant de savoir si l'utilisateur courant est professeur ou non */
/********************************************************************************/
function estEnseignant($uid){

global $ecoleCourant;
$estEnseignant = 0;
$tabDN = array();
$tabConn = array();
$tabDN[] = $ecoleCourant;

for($d=0;$d<count($tabDN);$d++){
    $tabConn[] = $_SESSION['connLdap'];
}

$filter = "(&(objectClass=posixGroup)(memberUid=$uid))";

$restriction = array();
$sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
for($e=0;$e<count($sr);$e++){
    $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
    do{
        if($entry != ''){
            $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
            
            if(preg_match("/-p/",$cn)){
                $estEnseignant = 1;
            }
        }                
    }
    while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
}

return $estEnseignant;
}


/**********************************************************************************/
/* Fonction permettant d'afficher les différents menu selon le type d'utilisateur */
/**********************************************************************************/
function afficheTypeMenu($service){

?>
<ul id="navigation">
<?php
if($_SESSION['estUtilisateur'] == 1 || $_SESSION['estUtilisateur'] == 2 || $_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){    
    affichageMenuActif($service,'cmp',"Changer votre mot de passe");
}

if($_SESSION['estUtilisateur'] == 2 || $_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'cmpce',"Changer le mot de passe d'une classe ou d'un enseignant");
}

if($_SESSION['estUtilisateur'] == 2 || $_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'aec',"Ajouter un enseignant");
}

// if($_SESSION['estUtilisateur'] == 2 || $_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    // affichageMenuActif($service,'de',"D&eacute;saffecter un enseignant");
// }

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'aae',"Gestion des affectations");
}

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'sed',"Supprimer un enseignant ou un directeur");
}

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'ped',"Gestion enseignants / directeurs");
}

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'cgt',"Cr&eacute;er un nouveau groupe th&eacute;matique");
}

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'ggt',"Gestion des groupes th&eacute;matiques");
}

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'cldap',"Afficher la console Ldap");
}

if($_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'alp',"Ajouter un login proxi");
}

if($_SESSION['estUtilisateur'] == 4){
    affichageMenuActif($service,'alis',"Ajouter un login internet/s&eacute;curit&eacute;");
}

affichageMenuActif($service,'d',"D&eacute;connexion");
?>
</ul>
<?php
}


/*********************************************************/
/* Fonction permettant d'afficher en grisé un menu actif */
/*********************************************************/
function affichageMenuActif($service,$typeService,$menuAff){
    
$colorMenuActif = 'style="background-color:#cccccc;"';

$menuActif = ($service == $typeService)?$colorMenuActif: '';
print '<li><a href="index.php?service='.$typeService.'" '.$menuActif.'>'.$menuAff.'</a></li>';
}
    
/*******************************************************************/
/* Fonction permettant de déconnecter un utilisateur de sa session */
/*******************************************************************/
function deconnectionUtilisateur(){

session_unset();
session_destroy();
}


/***************************************************************************/
/* Fonction permettant de changer le mot de passe de l'utilisateur courant */
/***************************************************************************/
function changementMotPasse($message){

?>
<form name="changementMotPasse" method="post" action="index.php" autocomplete="off" onSubmit="return valideChangementMotPasse(this,'messageAlerte');" class="well">
    <table border="0" class="alignleft">
        <tr>
            <td>
                Mot de Passe
            </td>
            <td>
                <INPUT type="password" id="changementPassword" name="changementPassword" value="" class="form-control input-sm" autocomplete="off" size="40" title="Saisir un mot de passe de 4 caractères minimum sans caractère spéciaux" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td>
                Confirmation du Mot de Passe&nbsp;
            </td>
            <td>
                <INPUT type="password" id="confirmationChangementPassword" name="confirmationChangementPassword" value="" class="form-control input-sm" autocomplete="off" size="40" title="Resaisir le même mot de passe" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td colspan="2" align="center">
                <br>
                <INPUT TYPE="hidden" name="service" VALUE="cmpAction">
                <INPUT TYPE="submit" NAME="changementMotPasse" VALUE="Modifier" class="btn btn-primary btn-sm">
            </td>
        </tr>
    </table>
</form>
<?php

if($message != ''){
    print $message;
}
else{
    ?>
    <div id="messageAlerte" class="alert alert-block alert-danger" style="display:none;"></div>
    <?php
}
}


/***************************************************************************/
/* Fonction permettant de changer le mot de passe de l'utilisateur courant */
/***************************************************************************/
function changementMotPasseAction($dnModif,$changementPassword,$confirmationChangementPassword){

$message='';
if($changementPassword == $confirmationChangementPassword && $changementPassword != '' && isset($_SESSION['ldapbind']) && $_SESSION['ldapbind'] != '' && isset($dnModif) && $dnModif != '' && isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    $tabValeurModif = array();
    $tabValeurModif['userPassword'] = chiffrementPassword($changementPassword);
    
    $errorTraitement = @ldap_modify($_SESSION['connLdap'],$dnModif,$tabValeurModif);
    if(!$errorTraitement){
        $message='<div class="alert alert-block alert-danger">Modification &eacute;chou&eacute;e</div>';
    }
    else{
        $message='<div class="alert alert-block alert-success">Modification r&eacute;ussie</div>';
    }
}
else{
    $message='<div class="alert alert-block alert-danger">Veuillez sp&eacute;cifier le m&ecirc;me mot de passe SVP</div>';
}

return $message;
}


/**********************************************************************************/
/* Fonction permettant de changer le mot de passe d'une classe ou d'un enseignant */
/**********************************************************************************/
function changementMotPasseClasseEnseignant($rc){

global $ecoleCourant;
$host = calculHostCourant();

// Affichage de la zone de sélection dans les interfaces
$tabEcole = zoneSelectionEcoleForm($host,'cmpce',$rc);

if($host != ''){
    // Récupération des enseignants et élèves liés au directeur courant par rapport à l'école
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }
    
    if($host == 9999){
        $filter = "(&(objectClass=posixGroup)(cn=*-*))";
    }
    else{
        $filter = "(&(objectClass=posixGroup)(cn=".$host."-*))";
    }

    $listeEnseignant='';
    $listeEleve='';
    $restriction = array();
    $affectationUtilisateur = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');

                if(preg_match("/-p/",$cn)){
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle)){
                            $listeEnseignant.="(uid=$valeur)";
                            $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                        }
                    }
                }
                else if(preg_match("/-e/",$cn)){
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle)){
                            $listeEleve.="(uid=$valeur)";
                            $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                        }
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Récupération des infos spécifiques à chaque enseignant et élève
    if($listeEnseignant != ''){
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabInfoEnseignant = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeEnseignant)$recherche)",1);
    }
    
    if($listeEleve != ''){
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabInfoEleve = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeEleve)$recherche)",1);
    }
    
    // Affichage des infos pour les enseignants et les élèves
    $nbEnseignant = count($tabInfoEnseignant);
    $nbEleve = count($tabInfoEleve);
    $nbCase = 6;
    $indice = 0;
    
    ?>
    <table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
        <thead>
            <tr class="colorGris">
                <td align="center" colspan="<?php echo $nbCase?>">
                    <?
                    if($nbEnseignant == 0){
                        print "Aucun Enseignant";
                    }
                    else if($nbEnseignant == 1){
                        print "1 Enseignant";
                    }
                    else{
                        print "$nbEnseignant Enseignants";
                    }
                    ?>
                </td>
            </tr>
    <?php
    if($nbEnseignant > 0){
        $indice = affichageInfoUtilisateur($tabInfoEnseignant,$indice,$host,$affectationUtilisateur,$tabEcole);
    }
    else{
        ?>
        </thead>
        <tbody>
        <?php
    }
    ?>
        </tbody>
    </table>
    <?php
    paginationTableau('#affichageResultat'.$indiceTable,count($tabInfoEnseignant));
    ?>
    <br>
    <table border="1" width="100%" id="affichageResultat2" class="table table-bordered table-striped table-condensed">
        <thead>
        <tr class="colorGris">
            <td align="center" colspan="<?php echo $nbCase?>">
                <?
                if($nbEleve == 0){
                    print "Aucune Classe";
                }
                else if($nbEleve == 1){
                    print "1 Classe";
                }
                else{
                    print "$nbEleve Classes";
                }
                ?>
            </td>
        </tr>
    <?php
    if($nbEleve > 0){
        $indice = affichageInfoUtilisateur($tabInfoEleve,$indice,$host,$affectationUtilisateur,$tabEcole);
    }
    else{
        ?>
        </thead>
        <tbody>
        <?php
    }
    ?>
        </tbody>
    </table>
    <?php
    paginationTableau('#affichageResultat2'.$indiceTable,count($tabInfoEleve));
}
else{
    if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
        print "Veuillez s&eacute;lectionner une &eacute;cole SVP";
    }
    else{
        print "Erreur";
    }
}
}


/*************************************************************************************/
/* Fonction permettant de récupérer dans Ldap les infos liés à certains utilisateurs */
/*************************************************************************************/
function getInfoUtilisateurLdap($filtre,$filtrageDN){

global $ecoleCourant;
$tabInfo = array();
if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    // Récupération des enseignant et élèves liés au directeur courant
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }
    
    $indice=0;
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filtre,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                if($filtrageDN == 1 && isset($_SESSION['dn']) && $_SESSION['dn'] == $dnCourant){
                    continue;
                }
    
                $tabInfo[$indice]['dn'] = $dnCourant;
                $tabInfo[$indice]['uid'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
                $tabInfo[$indice]['cn'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $tabInfo[$indice]['sn'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'sn'));
                $tabInfo[$indice]['givenName'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'givenName'));
                $tabInfo[$indice]['uidNumber'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uidNumber'));
                $tabInfo[$indice]['gidNumber'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                $tabInfo[$indice]['userPassword'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'userPassword'));
                $indice++;
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
}

return $tabInfo;
}


/******************************************************************************/
/* Fonction permettant d'afficher le détail des comptes enseignants et élèves */
/******************************************************************************/
function affichageInfoUtilisateur($tabInfo,$indice,$host,$affectationUtilisateur,$tabEcole){

?>
    <tr class="colorGris">
        <td align="center">
            Nom
        </td>
        <td align="center">
            Pr&eacute;nom
        </td>
        <td align="center">
            Identifiant
        </td>
        <?php
        if($host == 9999){
            ?>
            <td align="center">
                Affectation
            </td>
            <?php
        }
        ?>
        <td align="center">
            Mot de Passe
        </td>
        <td align="center">
            Modification
        </td>
    </tr>
</thead>
<tbody>
<?php

foreach($tabInfo as $cle => $valeur){
    ?>
    <tr>
        <td width="17%">
            <?php echo $valeur['sn']?>
        </td>
        <td width="17%">
            <?php echo $valeur['givenName']?>
        </td>
        <td width="17%">
            <?php echo $valeur['uid']?>
        </td>
        <?php
        if($host == 9999){
            ?>
            <td width="17%">
            <?php
            if($host == 9999){
                if(isset($affectationUtilisateur[$valeur['uid']]) && isset($tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'])){
                    print $tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'];
                }
                else{
                    print "Affectation Inconnue";
                }
            }
            ?>
            </td>
            <?php
        }
        ?>
        <td align="center" width="17%">
            <INPUT type="password" id="motPasseEE<?php echo $indice?>" name="motPasseEE<?php echo $indice?>" value="">
        </td>
        <td align="center" width="17%">
            <button type="submit" NAME="motPasseEEAction" class="btn btn-primary btn-sm" onClick="modificationMotPasseEE('<?php echo $valeur['dn']?>','motPasseEE<?php echo $indice?>','message<?php echo $indice?>','messageModification');return false;">Modifier</button>
            <div id="message<?php echo $indice?>" class="messageModification"></div>
        </td>
    </tr>
    <?php
    $indice++;
}

return $indice;
}


/*****************************************************************************************/
/* Fonction permettant d'afficher le détail des comptes enseignants pour les désaffecter */
/*****************************************************************************************/
function affichageDesaffecterUtilisateur($tabInfo,$idTableau,$host,$affectationUtilisateur,$tabEcole){

?>
    <tr class="colorGris">
        <td align="center">
            Nom
        </td>
        <td align="center">
            Pr&eacute;nom
        </td>
        <td align="center">
            Identifiant
        </td>
        <?php
        if($host == 9999){
            ?>
            <td align="center">
                Affectation
            </td>
            <?php
        }
        ?>
        <td align="center">
            D&eacute;saffecter
        </td>
    </tr>
</thead>
<tbody>
<?php

foreach($tabInfo as $cle => $valeur){
    ?>
    <tr>
        <td width="20%">
            <?php echo $valeur['sn']?>
        </td>
        <td width="20%">
            <?php echo $valeur['givenName']?>
        </td>
        <td width="20%">
            <?php echo $valeur['uid']?>
        </td>
        <?php
        if($host == 9999){
            ?>
            <td width="20%">
                <?php
                if(isset($affectationUtilisateur[$valeur['uid']]) && isset($tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'])){
                    print $tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'];
                }
                else{
                    print "Affectation Inconnue";
                }
                ?>
            </td>
            <?php
        }
        ?>
        <td align="center" width="20%">
            <button type="submit" NAME="desaffecterEnseignant" class="btn btn-primary btn-sm" onClick="desaffecterEnseignant('<?php echo $valeur['uid']?>',this,'<?php echo $idTableau?>');return false;">D&eacute;saffecter</button>
        </td>
    </tr>
<?php
}
}


/****************************************************/
/* Fonction permettant de désaffecter un enseignant */
/****************************************************/
function desaffecterEnseignantAction(){

global $ecoleCourant;
$message='';
$uid = initialisationVariableFormulaire('uid');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $uid != ''){
    $tabMember = array();
    $tabMember['memberUid'] = $uid;
    
    // On supprime cet utilisateur du groupe enseignant de l'école courante
    $host = calculHostCourant();
    if($host != ''){
        $groupe = $host.'-p';
        if($groupe != ''){
            @ldap_mod_del($_SESSION['connLdap'],"cn=$groupe,ou=groupes,$ecoleCourant",$tabMember);
            
            // On ajoute cet utilisateur dans le groupe des désaffectés
            @ldap_mod_add($_SESSION['connLdap'],"cn=desaffecter,ou=groupes,$ecoleCourant",$tabMember);
        }
    }
}

return $message;
}


/**********************************************************/
/* Fonction permettant de créer un enseignant ou un élève */
/**********************************************************/
function creationClasseEnseignant($type,$nom,$prenom,$message){

$tabEcole = listeEcole();
$tabEcoleActive = listeEcoleActiveLdap();

$checkEleve='';
$checkEnseignant='';
if($type == 'eleve'){
    $checkEleve='checked';
}
if($type == 'enseignant'){
    $checkEnseignant='checked';
}

?>
<form name="formCreationClasseEnseignant" method="post" action="index.php" autocomplete="off" class="well" onsubmit="return confirmationAjoutEnseignant();">
    <table border="0" class="alignleft">
        <tr>
            <td>
                Nom
            </td>
            <td>
                <INPUT type="text" id="nom" name="nom" value="<?php echo $nom?>" class="form-control input-sm" size="40" title="Saisir le nom de famille de la personne" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td>
                Pr&eacute;nom
            </td>
            <td>
                <INPUT type="text" id="prenom" name="prenom" value="<?php echo $prenom?>" class="form-control input-sm" size="40" title="Saisir le prénom de la personne" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <?php
        if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
            ?>
            <tr>
                <td>
                    Choix d'une &eacute;cole&nbsp;
                </td>
                <td>
                    <select name="host" id="host" style="width:100%;" class="hauteurSelect" class="form-control input-sm" title="Choisir une école parmis celle active" data-toggle="tooltip" data-placement="right">
                        <?php
                        foreach($tabEcoleActive as $cleTabEcole => $valeurTabEcole){
                            ?>
                            <option value='<?php echo $cleTabEcole?>'><?php echo $tabEcole[$cleTabEcole]['nom']?></option>
                            <?php
                        }
                        ?>
                    </select>
                </td>
            </tr>
            <?php
        }
        ?>
        <tr>
            <td colspan="2" align="center">
                <br>
                <INPUT TYPE="hidden" name="type" VALUE="enseignant">
                <INPUT TYPE="hidden" name="service" VALUE="aecAction">
                <INPUT TYPE="submit" NAME="creationClasseEnseignant" VALUE="Ajouter" class="btn btn-primary btn-sm">
            </td>
        </tr>
    </table>
</form>
<?php

if($message != ''){
    print $message;
}
}


/**************************************************/
/* Fonction permettant de calculer l'hôte courant */
/**************************************************/
function calculHostCourant(){

$host='';
global $ecoleCourant;

if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
    $host = initialisationVariableFormulaire('host');
}
else{
    if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && isset($_SESSION['uid']) && $_SESSION['uid'] != ''){
        $tabDN = array();
        $tabConn = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }
        
        $filter = "(&(objectClass=posixGroup)(memberUid=".$_SESSION['uid']."))";        
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                    $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                    
                    if(preg_match("/-p$/",$cn)){
                        $host = preg_replace('/-p$/','',$cn);
                    }
                }                
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }
    }
}

return $host;
}


/**********************************************************/
/* Fonction permettant de créer un enseignant ou un élève */
/**********************************************************/
function creationClasseEnseignantAction($type,$nom,$prenom){

$message='';
global $ecoleCourant;

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    if($type != '' && $nom != '' && $prenom != ''){
        
        $host = calculHostCourant();
        if($host != ''){
            $tabEcole = listeEcole();
            $uid = calculLogin($type,$nom,$prenom,$tabEcole,$host);
            $motPasse = calculMotPasse($type,$nom,$prenom,$tabEcole,$host);
            list($uidNumber,$debordementPlage) = calculUidNumber($tabEcole,$host,$type);
            $gidNumber = calculGidNumber($tabEcole,$host,0);

            if($uid != '' && $motPasse != '' && $uidNumber != '' && $gidNumber != ''){
                $info = array();
                $info['objectclass'][0] = 'top';
                $info['objectclass'][1] = 'person';
                $info['objectclass'][2] = 'inetOrgPerson';
                $info['objectclass'][3] = 'posixAccount';
                $info['objectclass'][4] = 'shadowAccount';

                $info['uid'] = $uid;
                $info['cn'] = $nom.' '.$prenom;
                $info['sn'] = $nom;
                $info['givenName'] = $prenom;
                $info['uidNumber'] = $uidNumber;
                $info['gidNumber'] = $gidNumber;
                $info['homeDirectory'] = "/home/$uid";
                $info['userPassword'] = chiffrementPassword($motPasse);
                $info['loginShell'] = '/bin/bash';
                
                $dnNouveau = "uid=$uid,ou=utilisateurs,$ecoleCourant";
                
                $errorTraitement = @ldap_add($_SESSION['connLdap'],$dnNouveau,$info);
                if(!$errorTraitement){
                    if(ldap_error($_SESSION['connLdap']) == 'Already exists'){
                        $message='<div class="alert alert-block alert-danger">Identifiant d&eacute;j&agrave; existant</div>';
                    }
                    else{
                        $message='<div class="alert alert-block alert-danger">Ajout &eacute;chou&eacute;</div>';
                    }
    
                    logFile("fonction: creationClasseEnseignantAction | ".ldap_error($_SESSION['connLdap']));
                }
                else{
                    //Ajouter cette entrée dans le groupe correspondant
                    $boolAjout = ajoutCompteGroupe($tabEcole,$host,$type,$uid);
                    if($boolAjout == 1){
                        $message='<div class="alert alert-block alert-success">Ajout r&eacute;ussi pour <b>'.$uid.'</b></div>';
                    }
                    else{
                        $message='<div class="alert alert-block alert-danger">Ajout &eacute;chou&eacute;</div>';
                    }
                }
            }
            else{
                if($debordementPlage == 1){
                    $message='<div class="alert alert-block alert-danger">D&eacute;bordement de la plage des num&eacute;ros d\'identifants</div>';
                }
                else{
                    $message='<div class="alert alert-block alert-danger">Erreur</div>';
                    logFile("fonction: creationClasseEnseignantAction | uid: $uid | motPasse: $motPasse | uidNumber: $uidNumber | gidNumber: $gidNumber");
                }
            }
        }
        else{
            $message='<div class="alert alert-block alert-danger">Erreur de localisation</div>';
            logFile("fonction: creationClasseEnseignantAction | host: $host");
        }
    }
    else{
        $message = '<div class="alert alert-block alert-danger">Veuillez sp&eacute;cifier tous les champs SVP</div>';
    }
}
else{
    $message='<div class="alert alert-block alert-danger">Erreur Ldap</div>';
}

return $message;
}


/****************************************************************************/
/* Fonction permettant de calculer un login en fonction du nom et du prénom */
/****************************************************************************/
function calculLogin($type,$nom,$prenom,$tabEcole,$host){

global $ecoleCourant;
$login='';
$nom = normalisationNomPrenom($nom);
$prenom = normalisationNomPrenom($prenom);

if($type == 'eleve'){
    if(isset($tabEcole[$host])){
        //Récupération de tous les uidMember du groupe ecole-e
        $tabDN = array();
        $tabConn = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }

        $filter = "(&(objectClass=posixGroup)(cn=$host-e))";
        
        $existeLogin = '';
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                    
                    $maxNumberUid=0;
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle)){
                            $numberUid = preg_replace('/^'.$host.'/','',$valeur);
                            
                            if(preg_match("/^[0-9]+$/",$numberUid)){
                                if($numberUid > $maxNumberUid){
                                    $maxNumberUid = $numberUid;
                                }
                            }
                        }
                    }
                    $maxNumberUid++;
                    $login = $host.$maxNumberUid;
                }
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }    
    }
}
else{    
    if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
        $login = substr($prenom,0,1).$nom;
        // On vérifie si ce login existe déjà sinon on incrémente la valeur
        $tabDN = array();
        $tabConn = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }

        $filter = "(&(objectClass=person)(uid=$login*))";
        
        $tabExisteLogin = array();
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $uid = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
                    
                    $tabExisteLogin[$uid] = 1;
                }                
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }
        
        if(isset($tabExisteLogin[$login])){
            $boolSearchLoginInexistant = 1;
            $increment=1;
            while($boolSearchLoginInexistant){
                if(!isset($tabExisteLogin[$login.$increment])){
                    $login = $login.$increment;
                    $boolSearchLoginInexistant=0;
                }
                
                $increment++;
            }
        }
    }
}

return $login;
}


/****************************************************************************************/
/* Fonction permettant de normaliser les noms et les prénoms pour la création des login */
/****************************************************************************************/
function normalisationNomPrenom($data){

$data = enleverAccent($data);
$data = strtolower($data);
$data = preg_replace('/[^a-z0-9\-]+/','',$data);

return $data;
}


/**********************************************/
/* Fonction permettant d'enlever les accents  */
/**********************************************/
function enleverAccent($keywords){

$keywords = encodageCaractere($keywords);
$keywords = preg_replace('#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1',$keywords);
$keywords = preg_replace('#&([A-za-z]{2})(?:lig);#','\1',$keywords); // pour les ligatures e.g. '&oelig;'
$keywords = preg_replace('#&[^;]+;#','',$keywords); // supprime les autres caractères

return $keywords;
}


/**********************************************************************************************/
/* Fonction permettant d'encoder les chaines de caractères selon un certain modèle d'encodage */
/**********************************************************************************************/
function encodageCaractere($data){

$data = htmlentities($data,ENT_NOQUOTES,'iso-8859-1');

return $data;
}


/*******************************************************************/
/* Fonction permettant de calculer un mot de passe automatiquement */
/*******************************************************************/
function calculMotPasse($type,$nom,$prenom,$tabEcole,$host){

$motPasse='';

if($type == 'eleve'){
    if(isset($tabEcole[$host])){
        $motPasse = $tabEcole[$host]['mdp'];
    }
}
else{
    $initial = strtoupper(substr($prenom,0,1).substr($nom,0,1));
    if(isset($tabEcole[$host])){
        $motPasse = $tabEcole[$host]['mdp'].'-'.$initial;
    }
}

return $motPasse;
}


/*************************************************************/
/* Fonction permettant de loguer les erreurs dans un fichier */
/*************************************************************/
function logFile($message){

$file = fopen('./log/log.txt','a+');
$dateCourante = date("d/m/Y H:i:s");

fputs($file,$dateCourante.' | '.$message."\n"); 
fclose($file);
}


/************************************************/
/* Fonction permettant de calculer le uidNumber */
/************************************************/
function calculUidNumber($tabEcole,$host,$type){

$uidNumber='';
$debordementPlage = -1;

if(isset($tabEcole[$host])){
    $numEcole = $tabEcole[$host]['num'] + 9;
    
    // Récupération de tous les uidnumber commençant par ce numéro d'école
    $tabUidNumberEcole = getAllUidNumberNumEcole($numEcole);
    
    $minPlage = '';
    $maxPlage = '';
    if($type == 'eleve'){
        $minPlage = $numEcole * 1000 + 100;
        $maxPlage = $numEcole * 1000 + 999;
    }
    else if($type == 'enseignant'){
        $minPlage = $numEcole * 1000 + 10;
        $maxPlage = $numEcole * 1000 + 99;
    }
    else if($type == 'directeur'){
        $minPlage = $numEcole * 1000 + 1;
        $maxPlage = $numEcole * 1000 + 9;
    }
    else{
        // type inconnue
    }
    
    if($minPlage != '' && $maxPlage != ''){
        $debordementPlage = 0;
        for($p = $minPlage;$p <= $maxPlage;$p++){
            if(!isset($tabUidNumberEcole[$p])){
                $uidNumber = $p;
                break;
            }
        }
        
        if($uidNumber == ''){
            $debordementPlage = 1;
        }
    }
}

return array($uidNumber,$debordementPlage);
}


/************************************************/
/* Fonction permettant de calculer le gidNumber */
/************************************************/
function getAllUidNumberNumEcole($numEcole){

$tabUidNumberEcole = array();

global $ecoleCourant;

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $numEcole != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(objectClass=person)";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $uidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uidNumber'));
                if(preg_match("/^$numEcole/",$uidNumber)){
                    $tabUidNumberEcole[$uidNumber] = 1;
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
}

return $tabUidNumberEcole;
}


/************************************************/
/* Fonction permettant de calculer le gidNumber */
/************************************************/
function calculGidNumber($tabEcole,$host,$type){

global $ecoleCourant;
$gidNumber='';

if($type == 1){
    // On recherche si le gidNumber 6000 existe, si non on le crée sinon on prend le max gidNumber en 6000 + 1
    $tabGidNumber = array();
    if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
        $tabDN = array();
        $tabConn = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }

        $filter = "(objectClass=posixGroup)";
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                    
                    if(preg_match("/^6/",$gidNumber)){
                        $tabGidNumber[$gidNumber] = 1;
                    }
                }                
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }
        
        if(count($tabGidNumber) == 0){
            $gidNumber = 6000;
        }
        else{
            for($p=6001;$p<=6999;$p++){
                if(!isset($tabGidNumber[$p])){
                    $gidNumber = $p;
                    break;
                }
            }
        }
    }
}
else{
    if(isset($tabEcole[$host])){
        $CNGroupe = $host;
        if($CNGroupe != ''){
            if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
                $tabDN = array();
                $tabConn = array();
                $tabDN[] = $ecoleCourant;

                for($d=0;$d<count($tabDN);$d++){
                    $tabConn[] = $_SESSION['connLdap'];
                }

                $filter = "(&(objectClass=posixGroup)(cn=$CNGroupe))";
                $restriction = array();
                $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
                for($e=0;$e<count($sr);$e++){
                    $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
                    do{
                        if($entry != ''){
                            $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                        }                
                    }
                    while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
                }
            }
        }
    }
}

return $gidNumber;
}


/**********************************************************/
/* Fonction permettant d'ajouter un compte dans un groupe */
/**********************************************************/
function ajoutCompteGroupe($tabEcole,$host,$type,$uid){

global $ecoleCourant;
$bool=0;

if(isset($tabEcole[$host])){
    $nomGroupe = $host;
    if($nomGroupe != ''){
        if($type == 'eleve'){
            $nomGroupe .='-e';
        }
        else{
            $nomGroupe .='-p';
        }
        
        // Recherche du groupe en question
        if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
            $tabDN = array();
            $tabConn = array();
            $tabDN[] = $ecoleCourant;

            for($d=0;$d<count($tabDN);$d++){
                $tabConn[] = $_SESSION['connLdap'];
            }

            $dnCourant='';
            $filter = "(&(objectClass=posixGroup)(cn=$nomGroupe))";
            $restriction = array();
            $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
            for($e=0;$e<count($sr);$e++){
                $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
                do{
                    if($entry != ''){
                        $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                    }                
                }
                while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
            }
            
            if($dnCourant != '' && $uid != ''){
                $tabMember = array();
                $tabMember['memberUid'] = $uid;
                
                @ldap_mod_add($_SESSION['connLdap'],$dnCourant,$tabMember);
                $bool=1;
                
                // Ajout au groupe principal de l'école courante
                @ldap_mod_add($_SESSION['connLdap'],"cn=$host,ou=groupes,$ecoleCourant",$tabMember);
            }            
        }
    }
}

return $bool;
}


/****************************************************/
/* Fonction permettant de désaffecter un enseignant */
/****************************************************/
function desaffecterEnseignant($rc){

global $ecoleCourant;
$host = calculHostCourant();

// Affichage de la zone de sélection dans les interfaces
$tabEcole = zoneSelectionEcoleForm($host,'de',$rc);

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $host != ''){
    // Récupération des enseignant lié au directeur courant (école courante)
    
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    if($host == 9999){
        $filter = "(&(objectClass=posixGroup)(cn=*-p))";
    }
    else{
        $filter = "(&(objectClass=posixGroup)(cn=$host-p))";
    }

    $listeEnseignant='';
    $restriction = array();
    $affectationUtilisateur = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));

                foreach($memberUid as $cle => $valeur){
                    if(preg_match("/^[0-9]+$/",$cle)){
                        $listeEnseignant.="(uid=$valeur)";
                        $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Récupération des infos spécifiques à chaque enseignant et élève
    if($listeEnseignant != ''){
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabInfoEnseignant = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeEnseignant)$recherche)",1);
    }
    
    // Affichage des infos pour les enseignants
    $nbEnseignant = count($tabInfoEnseignant);
    $nbCase = 5;
    
    ?>
    <table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
        <thead>
            <tr class="colorGris">
                <td align="center" colspan="<?php echo $nbCase?>">
                    <?
                    if($nbEnseignant == 0){
                        print "Aucun Enseignant";
                    }
                    else if($nbEnseignant == 1){
                        print "1 Enseignant";
                    }
                    else{
                        print "$nbEnseignant Enseignants";
                    }
                    ?>
                </td>
            </tr>
    <?php
    if($nbEnseignant > 0){
        affichageDesaffecterUtilisateur($tabInfoEnseignant,'affichageResultat',$host,$affectationUtilisateur,$tabEcole);
    }
    else{
        ?>
        </thead>
        <tbody>
        <?php
    }
    ?>
        </tbody>
    </table>
    <?php
    paginationTableau('#affichageResultat'.$indiceTable,count($tabInfoEnseignant));
}
else{
    if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
        print "Veuillez s&eacute;lectionner une &eacute;cole SVP";
    }
    else{
        print "Erreur";
    }
}
}


/******************************************************************/
/* Fonction permettant de supprimer un enseignant ou un directeur */
/******************************************************************/
function suppressionEnseignantDirecteur($rc){

global $ecoleCourant;
$host = calculHostCourant();

// Affichage de la zone de sélection dans les interfaces
$tabEcole = zoneSelectionEcoleForm($host,'sed',$rc);

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $host != ''){
    // Récupération de tous les directeurs et enseignants
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    if($host == 9999){
        $filter = "(&(objectClass=posixGroup)(|(cn=*-d)(cn=*-p)))";
    }
    else{
        $filter = "(&(objectClass=posixGroup)(|(cn=$host-d)(cn=$host-p)))";
    }
    
    $listeDirecteur = '';
    $listeEnseignant = '';
    $restriction = array();
    $affectationUtilisateur = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                
                if(preg_match("/-d$/",$cn)){
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle)){
                            $listeDirecteur.="(uid=$valeur)";
                            $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                        }
                    }
                }
                else{
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle)){
                            $listeEnseignant.="(uid=$valeur)";
                            $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                        }
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Calcul des agents qui ne sont affecté nul part
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(objectClass=person)";
    
    $listeAgentNonAffecte = '';
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $uid = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
            
                if(!isset($affectationUtilisateur[$uid])){
                    $listeAgentNonAffecte.="(uid=$uid)";
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }

    // Récupération des infos spécifiques à chaque directeur et enseignant
    if($listeDirecteur != ''){
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabInfoDirecteur = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeDirecteur)$recherche)",1);
    }    
    
    if($listeEnseignant != ''){
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabInfoEnseignant = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeEnseignant)$recherche)",1);
    }
    
    if($listeAgentNonAffecte != ''){
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabInfoAgentNonAffecte = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeAgentNonAffecte)$recherche)",1);
    }
    
    // Affichage des infos pour les directeurs et les enseignants
    $nbDirecteur = count($tabInfoDirecteur);
    $nbEnseignant = count($tabInfoEnseignant);
    $nbAgentNonAffecte = count($tabInfoAgentNonAffecte);
    $nbCase = 5;
    
    ?>
    <table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
        <thead>
            <tr class="colorGris">
                <td align="center" colspan="<?php echo $nbCase?>">
                    <?
                    if($nbDirecteur == 0){
                        print "Aucun Directeur";
                    }
                    else if($nbDirecteur == 1){
                        print "1 Directeur";
                    }
                    else{
                        print "$nbDirecteur Directeurs";
                    }
                    ?>
                </td>
            </tr>
    <?php
    if($nbDirecteur > 0){
        affichageSuppressionUtilisateur($tabInfoDirecteur,'affichageResultat',$host,$affectationUtilisateur,$tabEcole);
    }
    else{
        ?>
        </thead>
        <tbody>
        <?php
    }
    ?>
        </tbody>
    </table>
    <?php
    paginationTableau('#affichageResultat',count($tabInfoDirecteur));
    ?>
    <br>
    <table border="1" width="100%" id="affichageResultat2" class="table table-bordered table-striped table-condensed">
        <thead>
            <tr class="colorGris">
                <td align="center" colspan="<?php echo $nbCase?>">
                    <?
                    if($nbEnseignant == 0){
                        print "Aucun Enseignant";
                    }
                    else if($nbEnseignant == 1){
                        print "1 Enseignant";
                    }
                    else{
                        print "$nbEnseignant Enseignants";
                    }
                    ?>
                </td>
            </tr>
    <?php
    if($nbEnseignant > 0){
        affichageSuppressionUtilisateur($tabInfoEnseignant,'affichageResultat2',$host,$affectationUtilisateur,$tabEcole);
    }
    else{
        ?>
        </thead>
        <tbody>
        <?php
    }
    ?>
        </tbody>
    </table>
    <?php
    paginationTableau('#affichageResultat2',count($tabInfoDirecteur));
    if($host == 9999){
        ?>
        <br>
        <table border="1" width="100%" id="affichageResultat3" class="table table-bordered table-striped table-condensed">
            <thead>
                <tr class="colorGris">
                    <td align="center" colspan="<?php echo $nbCase?>">
                        <?
                        if($nbAgentNonAffecte == 0){
                            print "Aucun Agent Non Affect&eacute;";
                        }
                        else if($nbAgentNonAffecte == 1){
                            print "1 Agent Non Affect&eacute;";
                        }
                        else{
                            print "$nbAgentNonAffecte Agents Non Affect&eacute;s";
                        }
                        ?>
                    </td>
                </tr>
        <?php
        if($nbAgentNonAffecte > 0){
            affichageSuppressionUtilisateur($tabInfoAgentNonAffecte,'affichageResultat3',$host,$affectationUtilisateur,$tabEcole);
        }
        else{
            ?>
            </thead>
            <tbody>
            <?php
        }
        ?>
            </tbody>
        </table>    
        <?php
        paginationTableau('#affichageResultat3',count($tabInfoAgentNonAffecte));
    }
}
else{
    if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
        print "Veuillez s&eacute;lectionner une &eacute;cole SVP";
    }
    else{
        print "Erreur";
    }
}
}


/*****************************************************************************************************/
/* Fonction permettant d'afficher le détail des comptes directeurs et enseignants pour les supprimer */
/*****************************************************************************************************/
function affichageSuppressionUtilisateur($tabInfo,$idTableau,$host,$affectationUtilisateur,$tabEcole){

?>
    <tr class="colorGris">
        <td align="center">
            Nom
        </td>
        <td align="center">
            Pr&eacute;nom
        </td>
        <td align="center">
            Identifiant
        </td>
        <?php
        if($host == 9999){
            ?>
            <td align="center">
                Affectation
            </td>
            <?php
        }
        ?>
        <td align="center">
            Suppression
        </td>
    </tr>
</thead>
<tbody>
<?php
uasort($tabInfo,'triUid');    
foreach($tabInfo as $cle => $valeur){
    ?>
    <tr>
        <td width="20%">
            <?php echo $valeur['sn']?>
        </td>
        <td width="20%">
            <?php echo $valeur['givenName']?>
        </td>
        <td width="20%">
            <?php echo $valeur['uid']?>
        </td>
        <?php
        if($host == 9999){
            ?>
            <td width="20%">
                <?php
                if(isset($affectationUtilisateur[$valeur['uid']]) && isset($tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'])){
                    print $tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'];
                }
                else{
                    print "Affectation Inconnue";
                }
                ?>
            </td>
            <?php
        }
        ?>
        <td align="center" width="20%">
            <button type="submit" NAME="suppressionCompte" class="btn btn-primary btn-sm" onClick="suppressionCompte('<?php echo $valeur['dn']?>',this,'<?php echo $idTableau?>');return false;">Supprimer</button>
        </td>
    </tr>
<?php
}
}


/**********************************************************/
/* Fonction permettant de supprimer un compte utilisateur */
/**********************************************************/
function suppressionCompteAction(){

global $ecoleCourant;
$dn = initialisationVariableFormulaire('dn');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && isset($_SESSION['ldapbind']) && $_SESSION['ldapbind'] != '' && $dn != ''){
    // Supression dans les memberUid de l'uid courant
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $dn;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }
    
    $filter = "(objectClass=*)";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $uidSearch = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    $tabMember = array();
    $tabMember['memberUid'] = $uidSearch;
    
    // Parcours de tous les groupes pour supprimer le uid
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }
    
    $filter = "(&(objectClass=posixGroup)(memberUid=$uidSearch))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                @ldap_mod_del($_SESSION['connLdap'],$dnCourant,$tabMember);
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Suppression du compte sudoers si il y en a un
    if($uidSearch != ''){
        @ldap_delete($_SESSION['connLdap'],"cn=$uidSearch,ou=SUDOers,$ecoleCourant");
    }
    
    // Suppression du compte
    @ldap_delete($_SESSION['connLdap'],$dn);
}
}


/************************************************************/
/* Fonction permettant de migrer un enseignant en directeur */
/************************************************************/
function migrationEnseignantDirecteur($rc){

global $ecoleCourant;
$host = calculHostCourant();

// Affichage de la zone de sélection dans les interfaces
$tabEcole = zoneSelectionEcoleForm($host,'ped',$rc);

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $host != ''){
    // Récupération de tous les directeurs
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    if($host == 9999){
        $filter = "(&(objectClass=posixGroup)(cn=*-d))";
    }
    else{
        $filter = "(&(objectClass=posixGroup)(cn=$host-d))";
    }

    $tabDirecteur = array();
    $restriction = array();
    $affectationUtilisateur = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                
                foreach($memberUid as $cle => $valeur){
                    if(preg_match("/^[0-9]+$/",$cle)){
                        $tabDirecteur[$valeur] = 1;
                        $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    $listeDirecteurUniquement='';
    foreach($tabDirecteur as $cle => $valeur){
        $listeDirecteurUniquement.="(uid=$cle)";
    }
    
    // Récupération de tous les enseignants
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    if($host == 9999){
        $filter = "(&(objectClass=posixGroup)(|(cn=*-p)(cn=*-d)))";
    }
    else{
        $filter = "(&(objectClass=posixGroup)(|(cn=$host-p)(cn=$host-d)))";
    }

    $tabDirecteur = array();
    $tabEnseignant = array();
    $restriction = array();
    $affectationUtilisateur = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                
                foreach($memberUid as $cle => $valeur){
                    if(preg_match("/^[0-9]+$/",$cle)){
                        if(preg_match("/-d$/",$cn)){
                            $tabDirecteur[$valeur] = 1;
                        }
                        else{
                            $tabEnseignant[$valeur] = 1;
                        }
                        $affectationUtilisateur[$valeur] = preg_replace('/-.$/','',$cn);
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    $listeEnseignantUniquement='';
    foreach($tabEnseignant as $cle => $valeur){
        if(!isset($tabDirecteur[$cle])){
            $listeEnseignantUniquement.="(uid=$cle)";
        }
    }
    
    if($listeDirecteurUniquement != ''){
        // Récupération des infos spécifiques à chaque enseignant
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabDirecteurUniquement = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeDirecteurUniquement)$recherche)",1);
        
        // Affichage des infos pour les enseignants
        $nbDirecteur = count($tabDirecteurUniquement);
        $nbCase = 5;
        
        ?>
        <table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
            <thead>
                <tr class="colorGris">
                    <td align="center" colspan="<?php echo $nbCase?>">
                        <?
                        if($nbDirecteur == 0){
                            print "Aucun Directeur";
                        }
                        else if($nbDirecteur == 1){
                            print "1 Directeur";
                        }
                        else{
                            print "$nbDirecteur Directeurs";
                        }
                        ?>
                    </td>
                </tr>
        <?php
        if($nbDirecteur > 0){
            affichageDestitutionDirecteur($tabDirecteurUniquement,'affichageResultat',$host,$affectationUtilisateur,$tabEcole);
        }
        else{
            ?>
            </thead>
            <tbody>
            <?php
        }
        ?>
            </tbody>
        </table>
        <?php
        paginationTableau('#affichageResultat',count($tabDirecteurUniquement));
    }
    else{
        print "Aucun Directeur";
    }
    
    if($listeEnseignantUniquement != ''){
        // Récupération des infos spécifiques à chaque enseignant
        $recherche='';
        if($rc != ''){
            $recherche = "(|(uid=*$rc*)(givenName=*$rc*)(sn=*$rc*))";
        }
        $tabEnseignantUniquement = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeEnseignantUniquement)$recherche)",1);
        
        // Récupération de la liste des écoles actives
        $tabEcoleActive = listeEcoleActiveLdap();
        
        // Affichage des infos pour les enseignants
        $nbEnseignant= count($tabEnseignantUniquement);
        $nbCase = 5;
        
        ?>
        <table border="1" width="100%" id="affichageResultat2" class="table table-bordered table-striped table-condensed">
            <thead>
                <tr class="colorGris">
                    <td align="center" colspan="<?php echo $nbCase?>">
                        <?
                        if($nbEnseignant == 0){
                            print "Aucun Enseignant";
                        }
                        else if($nbEnseignant == 1){
                            print "1 Enseignant";
                        }
                        else{
                            print "$nbEnseignant Enseignants";
                        }
                        ?>
                    </td>
                </tr>
        <?php
        if($nbEnseignant > 0){
            affichageMigrationEnseignantDirecteur($tabEnseignantUniquement,'affichageResultat2',$host,$affectationUtilisateur,$tabEcole,$tabEcoleActive);
        }
        else{
            ?>
            </thead>
            <tbody>
            <?php
        }
        ?>
            </tbody>
        </table>
        <?php
        paginationTableau('#affichageResultat2',count($tabEnseignantUniquement));
    }
    else{
        print "Aucun Enseignant";
    }
}
else{
    if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
        print "Veuillez s&eacute;lectionner une &eacute;cole SVP";
    }
    else{
        print "Erreur";
    }
}
}


/*************************************************************************************************/
/* Fonction permettant d'afficher le détail des comptes enseignants pour les migrer en directeur */
/*************************************************************************************************/
function affichageMigrationEnseignantDirecteur($tabInfo,$idTableau,$host,$affectationUtilisateur,$tabEcole,$tabEcoleActive){

?>
    <tr class="colorGris">
        <td align="center">
            Nom
        </td>
        <td align="center">
            Pr&eacute;nom
        </td>
        <td align="center">
            Identifiant
        </td>
        <?php
        if($host == 9999){
            ?>
            <td align="center">
                Affectation
            </td>
            <?php
        }
        ?>
        <td align="center">
            Promotion
        </td>
    </tr>
</thead>
<tbody>
<?php
uasort($tabInfo,'triUid');    
foreach($tabInfo as $cle => $valeur){
    ?>
    <tr>
        <td width="20%">
            <?php echo $valeur['sn']?>
        </td>
        <td width="20%">
            <?php echo $valeur['givenName']?>
        </td>
        <td width="20%">
            <?php echo $valeur['uid']?>
        </td>
        <?php
        if($host == 9999){
            ?>
            <td width="20%">
                <?php
                if(isset($affectationUtilisateur[$valeur['uid']]) && isset($tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'])){
                    print $tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'];
                }
                else{
                    print "Affectation Inconnue";
                }
                ?>
            </td>
            <?php
        }
        ?>
        <td align="center" width="20%">
            <table border="0">
                <tr>
                    <td>
                        <select name="affectationDirecteur" id="affectationDirecteur" class="hauteurSelect" class="form-control input-sm">
                            <?php
                            foreach($tabEcoleActive as $cleTabEcole => $valeurTabEcole){
                                $check='';
                                if($host == $cleTabEcole){
                                    $check = 'selected';
                                }
                                ?>
                                <option value='<?php echo $cleTabEcole?>' <?php echo $check?>><?php echo $tabEcole[$cleTabEcole]['nom']?></option>
                                <?php
                            }
                            ?>
                        </select>
                    </td>
                    <td>
                        <button type="submit" NAME="migrationEnseignantDirecteur" class="btn btn-primary btn-sm" onClick="migrationEnseignantDirecteur('<?php echo $valeur['uid']?>',this,'<?php echo $idTableau?>');return false;">Promotion</button>
                    </td>
                </tr>
            </table>            
        </td>
    </tr>
<?php
}
}


/************************************************************/
/* Fonction permettant de migrer un enseignant en directeur */
/************************************************************/
function migrationEnseignantDirecteurAction(){

global $ecoleCourant;
$uid = initialisationVariableFormulaire('uid');
$affectationDirecteur = initialisationVariableFormulaire('affectationDirecteur');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && isset($_SESSION['ldapbind']) && $_SESSION['ldapbind'] != '' && $uid != '' && $affectationDirecteur != ''){
    $tabMember = array();
    $tabMember['memberUid'] = $uid;
    
    // Ajout de l'enseignant dans l'école sélectionnée
    @ldap_mod_add($_SESSION['connLdap'],"cn=$affectationDirecteur-d,ou=groupes,$ecoleCourant",$tabMember);

    // Ajout au groupe sudoers de ce nouveau directeur    
    $info = array();
    $info['objectclass'][0] = 'top';
    $info['objectclass'][1] = 'sudoRole';

    $info['sudoCommand'] = 'ALL';
    $info['sudoHost'] = 'ALL';
    $info['sudoOption'] = 'authenticate';
    $info['sudoRunAsUser'] = 'ALL';
    $info['sudoUser'] = $uid;
    $info['cn'] = $uid;

    $dnNouveau = "cn=$uid,ou=sudoers,$ecoleCourant";
    
    $errorTraitement = @ldap_add($_SESSION['connLdap'],$dnNouveau,$info);
    if(!$errorTraitement){
        logFile("fonction: migrationEnseignantDirecteurAction | $uid | ".ldap_error($_SESSION['connLdap']));
    }
    
    // Changement du gidNumber de ce directeur en 9000
    $tabValeurModif = array();
    $tabValeurModif['gidNumber'] = 9000;
    
    $dnModif = "uid=$uid,ou=utilisateurs,$ecoleCourant";
    
    $errorTraitement = @ldap_modify($_SESSION['connLdap'],$dnModif,$tabValeurModif);
    if(!$errorTraitement){
        logFile("fonction: migrationEnseignantDirecteurAction | $uid | ".ldap_error($_SESSION['connLdap']));
    }
    
    // Ajout de ce directeur dans le groupe de la direction globale
    $errorTraitement = @ldap_mod_add($_SESSION['connLdap'],"cn=direction,ou=groupes,$ecoleCourant",$tabMember);
    if(!$errorTraitement){
        logFile("fonction: migrationEnseignantDirecteurAction | $uid | ".ldap_error($_SESSION['connLdap']));
    }
}
}


/*************************************************************/
/* Fonction permettant de créer un nouveau groupe thématique */
/*************************************************************/
function creationGroupeThematique($message,$login,$description){

?>
<form name="formcreationGroupeThematique" method="post" action="index.php" autocomplete="off" class="well">
    <table border="0" class="alignleft">
        <tr>
            <td>
                Identifiant
            </td>
            <td>
                <INPUT type="text" id="login" name="login" value="<?php echo $login?>" class="form-control input-sm" size="40" title="Saisir le nom du groupe" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td>
                Description&nbsp;
            </td>
            <td>
                <INPUT type="text" id="description" name="description" value="<?php echo $description?>" class="form-control input-sm" size="40" title="Saisir la description du groupe" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td colspan="2" align="center">
                <br>
                <INPUT TYPE="hidden" name="service" VALUE="cgtAction">
                <INPUT TYPE="submit" NAME="creationGroupeThematique" VALUE="Ajouter" class="btn btn-primary btn-sm">
            </td>
        </tr>
    </table>
</form>
<?php

if($message != ''){
    print $message;
}
}


/*************************************************************/
/* Fonction permettant de créer un nouveau groupe thématique */
/*************************************************************/
function creationGroupeThematiqueAction($login,$description){

$message='';
global $ecoleCourant;

$login = enleverAccent($login);
$login = strtolower($login);

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    if($login != '' && $description != ''){
        $gidNumber = calculGidNumber('','',1);
        
        if($gidNumber != ''){
            $info = array();
            $info['objectclass'][0] = 'top';
            $info['objectclass'][1] = 'posixGroup';

            $info['cn'] = $login;
            $info['description'] = $description;
            $info['gidNumber'] = $gidNumber;
            
            $dnNouveau = "cn=$login,ou=groupes,$ecoleCourant";
            
            $errorTraitement = @ldap_add($_SESSION['connLdap'],$dnNouveau,$info);
            if(!$errorTraitement){                
                if(ldap_error($_SESSION['connLdap']) == 'Already exists'){
                    $message='<div class="alert alert-block alert-danger">Identifiant d&eacute;j&agrave; existant</div>';
                }
                else{
                    $message='<div class="alert alert-block alert-danger">Ajout &eacute;chou&eacute;</div>';
                }
        
                logFile("fonction: creationGroupeThematiqueAction | ".ldap_error($_SESSION['connLdap']));
            }
            else{
                $message='<div class="alert alert-block alert-success">Ajout r&eacute;ussi</div>';
            }
        }
        else{
            $message='<div class="alert alert-block alert-danger">Erreur GidNumber</div>';
            logFile("fonction: creationGroupeThematiqueAction | uid: $uid | motPasse: $motPasse | uidNumber: $uidNumber | gidNumber: $gidNumber");
        }
    }
    else{
        $message = '<div class="alert alert-block alert-danger">Veuillez sp&eacute;cifier tous les champs SVP</div>';
    }
}
else{
    $message='<div class="alert alert-block alert-danger">Erreur Ldap</div>';
}

return $message;
}


/***********************************************************/
/* Fonction permettant de créer un compte proxy ou de test */
/***********************************************************/
function creationCompteAdminProxy($type,$message,$service,$nom,$prenom,$loginAdmin,$passwordAdmin){

?>
<form name="formcreationCompteAdminProxy" method="post" action="index.php" autocomplete="off" onSubmit="return valideCreationMotPasseAdmin(this);" class="well">
    <table border="0" class="alignleft">
        <tr>
            <td>
                Nom
            </td>
            <td>
                <INPUT type="text" id="nom" name="nom" value="<?php echo $nom?>" class="form-control input-sm" size="40" title="Saisir le nom de famille de l'utilisateur" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td>
                Pr&eacute;nom
            </td>
            <td>
                <INPUT type="text" id="prenom" name="prenom" value="<?php echo $prenom?>" class="form-control input-sm" size="40" title="Saisir le prénom de l'utilisateur" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td>
                Identifiant
            </td>
            <td>
                <INPUT type="text" id="loginAdmin" name="loginAdmin" value="<?php echo $loginAdmin?>" class="form-control input-sm" size="40" title="Saisir l'identifiant de l'utilisateur" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td>
                Mot de Passe&nbsp;
            </td>
            <td>
                <INPUT type="password" id="passwordAdmin" name="passwordAdmin" value="<?php echo $passwordAdmin?>" class="form-control input-sm" size="40" title="Saisir le mot de passe de l'utilisateur" data-toggle="tooltip" data-placement="right">
            </td>
        </tr>
        <tr>
            <td colspan="2" align="center">
                <br>
                <INPUT TYPE="hidden" name="service" VALUE="alpalisAction">
                <INPUT TYPE="hidden" name="serviceAppel" VALUE="<?php echo $service?>">
                <INPUT TYPE="hidden" name="type" VALUE="<?php echo $type?>">
                <INPUT TYPE="submit" NAME="creationCompteAdminProxy" VALUE="Ajouter" class="btn btn-primary btn-sm">
            </td>
        </tr>
    </table>
</form>
<?php

if($message != ''){
    print $message;
}

affichageGestionCompteAdmin($type);
}


/****************************************************************/
/* Fonction permettant de gérer les comptes d'admin et de proxi */
/****************************************************************/
function affichageGestionCompteAdmin($type){

global $ecoleCourant;

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $typeAdmin='';
    $listeAdmin='';
    $typeAff='';
    if($type == 0){
        $typeAdmin = 'proxi';
        $typeAff = 'Administrateur Proximit&eacute;';
    }
    else{
        $typeAdmin = 'internet';
        $typeAff = 'Administrateur Internet';
    }
    $filter = "(&(objectClass=posixGroup)(cn=$typeAdmin))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                
                if(preg_match("/^8/",$gidNumber)){
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle)){
                            $listeAdmin.="(uid=$valeur)";
                        }
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    if($listeAdmin != ''){
        $tabAdmin = getInfoUtilisateurLdap("(&(objectClass=person)(|$listeAdmin))",0);
        
        // Affichage des infos pour administrateurs
        $nbAdmin = count($tabAdmin);
        $nbCase=5;
        $indice=0;
        
        ?>
        <br><br>
        <table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
            <thead>
                <tr class="colorGris">
                    <td align="center" colspan="<?php echo $nbCase?>">
                        <?
                        if($nbAdmin == 0){
                            print "Aucun $typeAff";
                        }
                        else if($nbAdmin == 1){
                            print "1 $typeAff";
                        }
                        else{
                            print "$nbAdmin $typeAff";
                        }
                        ?>
                    </td>
                </tr>
        <?php
        if($nbAdmin > 0){
            $indice = affichageInfoAdministrateur($tabAdmin,$indice,$type);
        }
        else{
            ?>
            </thead>
            <tbody>
            <?php
        }
        ?>
            </tbody>
        </table>
        <?php
        paginationTableau('#affichageResultat',count($tabAdmin));
    }
    else{
        print "Aucun Administrateur";
    }
}
}


/************************************************************************/
/* Fonction permettant d'afficher le détail des comptes administrateurs */
/************************************************************************/
function affichageInfoAdministrateur($tabInfo,$indice,$type){

?>
    <tr class="colorGris">
        <td align="center">
            Nom
        </td>
        <td align="center">
            Pr&eacute;nom
        </td>
        <td align="center">
            Identifiant
        </td>
        <td align="center">
            Suppression
        </td>
    </tr>
</thead>
<tbody>
<?php

foreach($tabInfo as $cle => $valeur){
    ?>
    <tr>
        <td width="20%">
            <?php echo $valeur['sn']?>
        </td>
        <td width="20%">
            <?php echo $valeur['givenName']?>
        </td>
        <td width="20%">
            <?php echo $valeur['uid']?>
        </td>
        <td align="center" width="20%">
            <button type="submit" NAME="suppressionAdmin" class="btn btn-primary btn-sm" onClick="suppressionAdmin('<?php echo $valeur['dn']?>','<?php echo $type?>','<?php echo $valeur['uid']?>');return false;">Supprimer</button>
        </td>
    </tr>
    <?php
    $indice++;
}

return $indice;
}


/***********************************************************/
/* Fonction permettant de créer un compte proxy ou de test */
/***********************************************************/
function creationCompteAdminProxyAction($type,$nom,$prenom,$login,$password){

$message='';
global $ecoleCourant;

$login = enleverAccent($login);
$login = strtolower($login);

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    if($type != '' && $nom != '' && $prenom != '' && $login != '' && $password != ''){
        $gidNumber='';
        if($type == 0){
            $gidNumber = 8100;
        }
        else{
            $gidNumber = 8000;
        }
        
        $uidNumber = calculUidNumberAdmin($gidNumber);
        if($uidNumber != ''){
            $info = array();
            $info['objectclass'][0] = 'top';
            $info['objectclass'][1] = 'person';
            $info['objectclass'][2] = 'inetOrgPerson';
            $info['objectclass'][3] = 'posixAccount';
            $info['objectclass'][4] = 'shadowAccount';

            $info['uid'] = $login;
            $info['cn'] = $nom.' '.$prenom;
            $info['sn'] = $nom;
            $info['givenName'] = $prenom;
            $info['uidNumber'] = $uidNumber;
            $info['gidNumber'] = $gidNumber;
            $info['homeDirectory'] = "/home/$login";
            $info['userPassword'] = chiffrementPassword($password);
            $info['loginShell'] = '/bin/bash';
            
            $dnNouveau = "uid=$login,ou=utilisateurs,$ecoleCourant";
            
            $errorTraitement = @ldap_add($_SESSION['connLdap'],$dnNouveau,$info);
            if(!$errorTraitement){
                if(ldap_error($_SESSION['connLdap']) == 'Already exists'){
                    $message='<div class="alert alert-block alert-danger">Identifiant d&eacute;j&agrave; existant</div>';
                }
                else{
                    $message='<div class="alert alert-block alert-danger">Ajout &eacute;chou&eacute;</div>';
                }
                
                logFile("fonction: creationClasseEnseignantAction | ".ldap_error($_SESSION['connLdap']));
            }
            else{
                //Ajouter cette entrée dans le groupe admin ou proxi
                $boolAjout = ajoutCompteGroupeAdmin($gidNumber,$login);
                if($boolAjout == 1){
                    $message='<div class="alert alert-block alert-success">Ajout r&eacute;ussi</div>';
                }
                else{
                    $message='<div class="alert alert-block alert-danger">Ajout &eacute;chou&eacute;</div>';
                }
            }
        }
        else{
            $message='<div class="alert alert-block alert-danger">Erreur UidNumber</div>';
            logFile("fonction: creationCompteAdminProxyAction | uidNumber: $uidNumber");
        }
    }
    else{
        $message = '<div class="alert alert-block alert-danger">Veuillez sp&eacute;cifier tous les champs SVP</div>';
    }
}
else{
    $message='<div class="alert alert-block alert-danger">Erreur Ldap</div>';
}

return $message;
}


/**************************************************************************/
/* Fonction permettant de calculer un uidNumber pour un admin ou un proxi */
/**************************************************************************/
function ajoutCompteGroupeAdmin($gidNumber,$login){

global $ecoleCourant;
$bool=0;

// Recherche du groupe en question
if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $dnCourant='';
    $filter = "(&(objectClass=posixGroup)(gidNumber=$gidNumber))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    if($dnCourant != '' && $login != ''){
        $tabMember = array();
        $tabMember['memberUid'] = $login;
        
        @ldap_mod_add($_SESSION['connLdap'],$dnCourant,$tabMember);
        $bool=1;
    }            
}

return $bool;
}


/**************************************************************************/
/* Fonction permettant de calculer un uidNumber pour un admin ou un proxi */
/**************************************************************************/
function calculUidNumberAdmin($gidNumber){

$uidNumber='';
global $ecoleCourant;

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(&(objectClass=posixGroup)(gidNumber=$gidNumber))";

    $listeUtilisateur='';
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                foreach($memberUid as $cle => $valeur){
                    if(preg_match("/^[0-9]+$/",$cle)){
                        $listeUtilisateur.="(uid=$valeur)";
                    }
                }
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // On récupère tous les uidNumber avec les uid pour trouver le plus grand
    if($listeUtilisateur != ''){
        $tabDN = array();
        $tabConn = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }

        $filter = "(&(objectClass=person)(|$listeUtilisateur))";

        $maxUidNumber = 0;
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $uidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uidNumber'));
                    
                    if($uidNumber > $maxUidNumber){
                        $maxUidNumber = $uidNumber;
                    }
                }                
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }
        
        $uidNumber = $maxUidNumber + 1;
    }
    else{
        $uidNumber = $gidNumber;
    }
}

return $uidNumber;
}


/***************************************************************************/
/* Fonction permettant de créer un enseignant et de l'affecter à une école */
/***************************************************************************/
function creationEnseignantEcole($rc){

global $ecoleCourant;

?>
<form name="selectionEcole" method="post" action="index.php" autocomplete="off">
    <table border="0">
        <tr>
            <td>
                <INPUT type="text" id="rc" name="rc" value="<?php echo $rc?>" class="form-control input-sm" size="40">
            </td>
            <td align="center">
                <INPUT TYPE="hidden" name="service" VALUE="aae">
                <button type="submit" NAME="selectionEcole" class="btn btn-primary btn-sm"><span class="glyphicon glyphicon-eye-open"></span> Chercher</button>
            </td>
        </tr>
    </table>
</form><br>
<?php

// Recherche du groupe en question
if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $tabEnseignant = array();
    $tabDesaffecter = array();
    $filter = "(&(objectClass=posixGroup)(|(cn=*-p)(cn=desaffecter)))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                
                foreach($memberUid as $cle => $valeur){
                    $cnFormalise = preg_replace('/-p$/','',$cn);
                    if($cn == 'desaffecter'){
                        $tabDesaffecter[$valeur]['ecole'][$cn] = $cnFormalise;
                    }
                    else{
                        $tabEnseignant[$valeur][$cn] = $cnFormalise;
                    }
                }
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Récupération de toutes les personnes
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $tabAllPersonne = array();
    $filter = "(&(objectClass=person)(objectClass=posixAccount))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $uid = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
                $sn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'sn'));
                $givenName = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'givenName'));
                
                if($rc == '' || preg_match("/".$rc."/i",$cn) || preg_match("/".$rc."/i",$uid) || preg_match("/".$rc."/i",$sn) || preg_match("/".$rc."/i",$givenName)){
                    if(!isset($tabDesaffecter[$uid])){
                        if(isset($tabEnseignant[$uid])){
                            $tabAllPersonne[$uid]['ecole'] = $tabEnseignant[$uid];
                        }
                        else{
                            $tabAllPersonne[$uid]['ecole'] = '';
                        }

                        $tabAllPersonne[$uid]['sn'] = $sn;
                        $tabAllPersonne[$uid]['givenName'] = $givenName;
                    }
                    else{
                        $tabDesaffecter[$uid]['ecole'] = $tabDesaffecter[$uid];
                        $tabDesaffecter[$uid]['sn'] = $sn;
                        $tabDesaffecter[$uid]['givenName'] = $givenName;
                    }
                }
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    $indice=0;
    $tabEcole = listeEcoleActiveLdap();

    $indice = affichageNouvelleAffectation($tabAllPersonne,$indice,$tabEcole,'Enseignant',0);
    // print "<br>";
    // $indice = affichageNouvelleAffectation($tabDesaffecter,$indice,$tabEcole,'D&eacute;saffect&eacute;',1);
}
}


/********************************************************************************************************/
/* Fonction permettant d'afficher les possibilités de nouvelles affectations pour certains utilisateurs */
/********************************************************************************************************/
function affichageNouvelleAffectation($tabData,$indice,$tabEcole,$typeAff,$indiceTable){

$nbCase = 5;
$nbTotalData = count($tabData);
?>
<table border="1" width="100%" id="affichageResultat<?php echo $indiceTable?>" class="table table-bordered table-striped table-condensed">
    <thead>
        <tr class="colorGris">
            <td align="center" colspan="<?php echo $nbCase?>">
                <?
                if($nbTotalData == 0){
                    print "Aucun $typeAff";
                }
                else if($nbTotalData == 1){
                    print "1 $typeAff";
                }
                else{
                    print "$nbTotalData ".$typeAff."s";
                }
                ?>
            </td>
        </tr>
        <tr class="colorGris">
            <td align="center" width="20%">
                Nom
            </td>
            <td align="center" width="20%">
                Pr&eacute;nom
            </td>
            <td align="center" width="20%">
                Identifiant
            </td>
            <td align="center" width="20%">
                Liste d'&eacute;coles
            </td>
            <td align="center" width="20%">
                Affectation
            </td>
        </tr>
    </thead>
    <tbody>
<?php
ksort($tabData);
foreach($tabData as $cle => $valeur){
    if(!preg_match("/^[0-9]+$/i",$cle)){
        // Recherche par enseignant de la liste des écoles disponibles par rapport à son compte
        $nbEcoleAffectation=0;
        foreach($tabEcole as $cleTabEcole => $valeurTabEcole){                        
            if(!isset($tabData[$cle]['ecole'][$cleTabEcole.'-p'])){
                $nbEcoleAffectation++;
            }
        }

        ?>
        <tr>
            <td align="center">
                <?php echo $valeur['sn']?>
            </td>
            <td align="center">
                <?php echo $valeur['givenName']?>
            </td>
            <td align="center">
                <?php echo $cle?>
            </td>
            <td align="center">
                <?php
                if($nbEcoleAffectation == 0){
                    print "Aucune affectation possible";
                }
                else{
                    ?>
                    <table border="0">
                        <tr>
                            <td>
                                <select name="listeEcole<?php echo $indice?>" id="listeEcole<?php echo $indice?>" class="hauteurSelect">
                                    <option value=''>Choix d'une &eacute;cole</option>
                                <?php
                                foreach($tabEcole as $cleTabEcole => $valeurTabEcole){                        
                                    if(!isset($tabData[$cle]['ecole'][$cleTabEcole.'-p'])){
                                        ?>
                                        <option value='<?php echo $cleTabEcole?>'><?php echo $tabEcole[$cleTabEcole]['nom']?></option>
                                        <?php
                                    }
                                }
                                ?>
                                </select>
                            </td>
                            <td>
                                <button type="submit" NAME="nouvelleAffectation" class="btn btn-primary btn-sm" onClick="nouvelleAffectation('<?php echo $cle?>','listeEcole<?php echo $indice?>');">Ajouter</button>
                            </td>
                        </tr>
                    </table>
                    <?php
                }
                ?>
            </td>
            <td align="center">
                <?php
                if(isset($valeur['ecole']) && $valeur['ecole'] != ''){
                ?>
                <table border="0" width="100%">
                <?php
                foreach($valeur['ecole'] as $cleEcole => $valeurEcole){
                    if(!preg_match("/^[0-9]+$/i",$cleEcole) && isset($tabEcole[$valeurEcole]['nom'])){
                        ?>
                        <tr>
                            <td align="center">
                                <?php echo $tabEcole[$valeurEcole]['nom']?>
                            </td>
                            <td align="center" width="25">
                                <a href="#" onClick="suppressionAffectation('<?php echo $cle?>','<?php echo $valeurEcole?>');">
                                    <img src="/image/suppression.png" border="0" width="25" height="25">
                                </a>
                            </td>
                        </tr>
                        <?php
                    }
                }                    
                ?>
                </table>
                <?php
                }
                else{
                    print "&nbsp;";
                }
                ?>
            </td>
        </tr>
        <?php
    }
    $indice++;
}

?>
    </tbody>
</table>
<?php
paginationTableau('#affichageResultat'.$indiceTable,count($tabData));

return $indice;
}


/*******************************************************************************************/
/* Fonction listant toutes les écoles avec leur abréviation et leur mot de passe respectif */
/*******************************************************************************************/
function listeEcole(){

$tabEcole = array();

$file = file_get_contents('./conf/ecoles.conf',true);
$ligne = preg_split("/[\n\r]/",$file);
$tabEcole = getHostConf($ligne,'host_test',$tabEcole);
$tabEcole = getHostConf($ligne,'host_prod',$tabEcole);

return $tabEcole;
}


/****************************************************************************************/
/* Fonction permettant de récupérer un bloc spécifique dans le fichier de configuration */
/****************************************************************************************/
function getHostConf($tabLigne,$bloc,$tabEcole){

$bool=0;
while(list($cle,$valeur) = each($tabLigne)){
    if(preg_match("/^\[".$bloc."\]/",$valeur)){
        $bool=1;
    }
    else if($bool == 1){
        if(preg_match("/^\[.*\]/",$valeur)){
            break;
        }
        else{
            if($valeur != ''){
                preg_match('/^([^ ]*)[ ]+nom=([^ ]*)[ ]+remote_port=[0-9]+[ ]+abbrv=([^ ]*)[ ]+mdp=([^ ]*)[ ]+num=([^ ]*)/',$valeur,$resultat);
                if(isset($resultat[1]) && isset($resultat[2]) && isset($resultat[3]) && isset($resultat[4]) && isset($resultat[5])){
                    $tabEcole[$resultat[3]]['host'] = $resultat[1];
                    $tabEcole[$resultat[3]]['nom'] = $resultat[2];
                    $tabEcole[$resultat[3]]['mdp'] = $resultat[4];
                    $tabEcole[$resultat[3]]['num'] = $resultat[5];
                }
            }
        }
    }
}

return $tabEcole;
}


/***********************************************************/
/* Fonction permettant d'ajouter un enseignant à une école */
/***********************************************************/
function affectationEnseignantGroupe(){

global $ecoleCourant;
$uid = initialisationVariableFormulaire('uid');
$nomEcole = initialisationVariableFormulaire('nomEcole');
$typeAction = initialisationVariableFormulaire('typeAction');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $uid != '' && $nomEcole != '' && $typeAction != ''){
    $tabMember = array();
    $tabMember['memberUid'] = $uid;
    
    if($typeAction == 1){
        @ldap_mod_del($_SESSION['connLdap'],"cn=$nomEcole-p,ou=groupes,$ecoleCourant",$tabMember);
    }
    else{
        @ldap_mod_add($_SESSION['connLdap'],"cn=$nomEcole-p,ou=groupes,$ecoleCourant",$tabMember);
        @ldap_mod_del($_SESSION['connLdap'],"cn=desaffecter,ou=groupes,$ecoleCourant",$tabMember);
    }
}
}


/*****************************************************************************/
/* Fonction permettant de récupérer uniquement les écoles présente dans ldap */
/*****************************************************************************/
function listeEcoleActiveLdap(){

global $ecoleCourant;
$tabEcole = listeEcole();
$tabEcoleActive = array();

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $tabEnseignant = array();
    $filter = "(&(objectClass=posixGroup)(cn=*-p))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $ecoleActive = preg_replace('/-p$/','',$cn);
                if(isset($tabEcole[$ecoleActive])){
                    $tabEcoleActive[$ecoleActive]['nom'] = $tabEcole[$ecoleActive]['nom'];
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
}

uasort($tabEcoleActive,'triEcole');

return $tabEcoleActive;
}


/********************************************************/
/* Fonction permettant de gérer les groupes thématiques */
/********************************************************/
function gestionGroupeThematique($rc){

global $ecoleCourant;
$tabGroupeThematique = array();

?>
<form name="selectionEcole" method="post" action="index.php" autocomplete="off">
    <table border="0">
        <tr>
            <td>
                <INPUT type="text" id="rc" name="rc" value="<?php echo $rc?>" class="form-control input-sm" size="40">
            </td>
            <td align="center">
                <INPUT TYPE="hidden" name="service" VALUE="ggt">
                <button type="submit" NAME="selectionEcole" class="btn btn-primary btn-sm"><span class="glyphicon glyphicon-eye-open"></span> Chercher</button>
            </td>
        </tr>
    </table>
</form><br>
<?php

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    // Récupération de tous les groupes thématiques
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $tabEnseignant = array();
    $filter = "(objectClass=posixGroup)";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $gidNumber = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                
                if(preg_match("/^6/",$gidNumber)){
                    $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                    $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                    $description = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'description'));
                    $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                    
                    if($rc != ''){                        
                        $boolMemberUid=0;
                        foreach($memberUid as $cle => $valeur){
                            if($valeur != '' && !preg_match("/^[0-9]+$/i",$valeur) && preg_match("/".$rc."/",$valeur)){
                                $boolMemberUid=1;
                                break;
                            }
                        }
                        
                        if($boolMemberUid == 0 && !(preg_match("/".$rc."/",$cn) || preg_match("/".$rc."/",$description))){
                            continue;
                        }
                    }
                    
                    $tabGroupeThematique[$gidNumber]['dn'] = $dnCourant;
                    $tabGroupeThematique[$gidNumber]['cn'] = $cn;
                    $tabGroupeThematique[$gidNumber]['description'] = $description;
                    $tabGroupeThematique[$gidNumber]['memberUid'] = $memberUid;
                }
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Récupération de tous les memberuid des groupes enseignant et directeur
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $listeUid = '';
    $tabUtilisateurDetail = array();
    $filter = "(&(objectClass=posixGroup)(|(cn=*-p)(cn=*-d)))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                
                foreach($memberUid as $cle => $valeur){
                    if($valeur != '' && !preg_match("/^[0-9]+$/i",$valeur)){
                        if(!isset($tabUtilisateurDetail[$valeur])){
                            $listeUid.="(uid=$valeur)";
                        }
                        $tabUtilisateurDetail[$valeur][$cn] = 1;
                    }
                }
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    if($listeUid != ''){
        // Récupération de tous les directeurs et enseignants
        $tabDN = array();
        $tabConn = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }

        $tabUtilisateur = array();
        $nbEnseignant=0;
        $nbDirecteur=0;
        $filter = "(&(objectClass=person)(|$listeUid))";
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $uid = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
                    $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                    
                    $tabUtilisateur[$uid]['dn'] = @ldap_get_dn($_SESSION['connLdap'],$entry);
                    $tabUtilisateur[$uid]['cn'] = $cn;
                    $tabUtilisateur[$uid]['sn'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'sn'));
                    $tabUtilisateur[$uid]['givenName'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'givenName'));
                    $tabUtilisateur[$uid]['uidNumber'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uidNumber'));
                    $tabUtilisateur[$uid]['gidNumber'] = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'gidNumber'));
                    
                    if(isset($tabUtilisateurDetail[$uid])){
                        foreach($tabUtilisateurDetail[$uid] as $cle => $valeur){
                            if(preg_match("/-p$/i",$cle)){
                                $tabUtilisateur[$uid]['type'] = 'p';
                                $nbEnseignant++;
                            }
                            else{
                                $tabUtilisateur[$uid]['type'] = 'd';
                                $nbDirecteur++;
                            }
                        }
                    }
                }
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }
        
        affichageGestionGroupeThematique($tabGroupeThematique,$tabUtilisateur,$tabUtilisateurDetail,$nbEnseignant,$nbDirecteur);
    }
    else{
        print "Aucun enseignant ou directeur dans aucune &eacute;cole<br>";
    }
}
}


/********************************************************/
/* Fonction permettant de gérer les groupes thématiques */
/********************************************************/
function affichageGestionGroupeThematique($tabGroupeThematique,$tabUtilisateur,$tabUtilisateurDetail,$nbEnseignant,$nbDirecteur){

$nbCase = 5;
$nbTotalGroupe = count($tabGroupeThematique);
?>
<table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
    <thead>
        <tr class="colorGris">
            <td align="center" colspan="<?php echo $nbCase?>">
                <?
                if($nbTotalGroupe == 0){
                    print "Aucun groupe th&eacute;matique";
                }
                else if($nbTotalGroupe == 1){
                    print "1 groupe th&eacute;matique";
                }
                else{
                    print "$nbTotalGroupe groupes th&eacute;matiques";
                }
                ?>
            </td>
        </tr>
        <tr class="colorGris">
            <td align="center" width="20%">
                Nom
            </td>
            <td align="center" width="20%">
                Description
            </td>
            <td align="center" width="20%">
                Ajouter un membre
            </td>
            <td align="center" width="20%">
                Membre(s)
            </td>
            <td align="center" width="20%">
                Suppression
            </td>
        </tr>
    </thead>
    <tbody>
<?php
$indice=0;
foreach($tabGroupeThematique as $cleGroupe => $valeurGroupe){
    ?>
    <tr>
        <td align="center" width="20%" style="vertical-align:middle;">
            <?php echo $valeurGroupe['cn']?>
        </td>
        <td align="center" width="20%" style="vertical-align:middle;">
            <?php echo $valeurGroupe['description']?>
        </td>
        <td align="center" width="20%" style="vertical-align:middle;">
            <?php
            $tabRealMembreAffichage = array();
            $nbRealMembreAffichage = 0;
            foreach($tabUtilisateur as $cleUtilisateur => $valeurUtilisateur){
                if(!in_array($cleUtilisateur,$valeurGroupe['memberUid'])){
                    $tabRealMembreAffichage[$cleUtilisateur] = $valeurUtilisateur;
                    $nbRealMembreAffichage++;
                }
            }
            
            if($nbRealMembreAffichage == 0){
                print "Aucun membre &agrave; ajouter";
            }
            else{
                ?>
                <table border="0">
                    <tr>
                        <td>
                            <select name="listeUtilisateurGroupeThematique<?php echo $indice?>" id="listeUtilisateurGroupeThematique<?php echo $indice?>" class="hauteurSelect">
                                <option value=''>Choisir un utilisateur</option>
                            <?php
                            ksort($tabRealMembreAffichage);
                            foreach($tabRealMembreAffichage as $cleUtilisateur => $valeurUtilisateur){
                                ?>
                                <option value='<?php echo $cleUtilisateur?>'><?php echo $cleUtilisateur?></option>
                                <?php
                            }
                            ?>
                            </select>
                        </td>
                        <td>
                            <button type="submit" NAME="utilisateurGroupeThematique" class="btn btn-primary btn-sm" onClick="affecterUtilisateurGroupeThematique('<?php echo $valeurGroupe['dn']?>','listeUtilisateurGroupeThematique<?php echo $indice?>');">Ajouter</button>
                        </td>
                    </tr>
                </table>
                <?php
            }
            ?>
        </td>
        <td align="center" width="20%" style="vertical-align:middle;">
            <?php
            if(count($valeurGroupe['memberUid']['count']) == 0){
                print "Aucun membre";
            }
            else{
                ?>
                <table border="0" width="100%">
                <?php
                foreach($valeurGroupe['memberUid'] as $cleMembre => $valeurMembre){
                    if(preg_match("/^[0-9]+$/i",$cleMembre) && $valeurMembre != ''){
                        ?>
                        <tr>
                            <td>
                                <?php echo $valeurMembre?>
                            </td>
                            <td width="25">
                                <a href="#" onClick="suppressionMembreGroupeThematique('<?php echo $valeurGroupe['dn']?>','<?php echo $valeurMembre?>');">
                                    <img src="/image/suppression.png" border="0" width="25" height="25">
                                </a>
                            </td>
                        </tr>
                        <?php
                    }
                }
                ?>
                </table>
                <?php
            }
            ?>
        </td>
        <td align="center" width="25" style="vertical-align:middle;">
            <a href="#" onClick="suppressionGroupeThematique('<?php echo $valeurGroupe['dn']?>','<?php echo $cleGroupe?>');">
                <img src="/image/suppression.png" border="0" width="25" height="25">
            </a>
        </td>
    </tr>
    <?php
    $indice++;
}

?>
    </tbody>
</table>
<?php
paginationTableau('#affichageResultat',count($tabGroupeThematique));
}


/********************************************************/
/* Fonction permettant de gérer les groupes thématiques */
/********************************************************/
function affectationUtilisateurGroupeThematique(){

$dnGroupe = initialisationVariableFormulaire('dnGroupe');
$uid = initialisationVariableFormulaire('uid');
$type = initialisationVariableFormulaire('type');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $dnGroupe != '' && $uid != '' && $type != ''){
    $tabMember = array();
    $tabMember['memberUid'] = $uid;

    if($type == 0){
        // On ajoute cet utilisateur dans le groupe thématique choisi
        @ldap_mod_add($_SESSION['connLdap'],$dnGroupe,$tabMember);
    }
    else{
        // On supprime cet utilisateur dans le groupe thématique choisi
        @ldap_mod_del($_SESSION['connLdap'],$dnGroupe,$tabMember);
    }
}
}


/*********************************************************/
/* Fonction permettant de supprimer un groupe thématique */
/*********************************************************/
function suppressionGroupeThematique(){

global $ecoleCourant;
$dnGroupe = initialisationVariableFormulaire('dnGroupe');
$gidNumber = initialisationVariableFormulaire('gidNumber');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $dnGroupe != '' && $gidNumber != ''){
    // Supression dans les gidNumber de tous les membres du groupe courant
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(&(objectClass=person)(gidNumber=$gidNumber))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $tabMember = array();
                $tabMember['gidNumber'] = $gidNumber;
    
                $dn = @ldap_get_dn($_SESSION['connLdap'],$entry);
                
                // On supprime le gidNumber des utilisateurs concernés
                @ldap_mod_del($_SESSION['connLdap'],$dn,$tabMember);
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Suppression du compte
    @ldap_delete($_SESSION['connLdap'],$dnGroupe);
}
}


/********************************************************************/
/* Fonction permettant d'afficher la console de ldap sous forme web */
/********************************************************************/
function affichageConsoleLdap($rc){

global $ecoleCourant;
$nbCase = 3;
$nbEntreeFiltre = 0;
$tabLdapDetail = array();
$tabDNCompo = array();
$tabDNFils = array();
$tabDNCompoReverse = array();
$tabDNMatchRecherche = array();

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != ''){
    // Récupération de tous les groupes thématiques
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(objectClass=*)";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $dnCourant = ldap_get_dn($_SESSION['connLdap'],$entry);
                $objectClass = @ldap_get_values($_SESSION['connLdap'],$entry,'objectClass');
                $tabDN = explode(',',$dnCourant);
                $tailleTabDN = count($tabDN);
                
                if($rc != '' && preg_match("/".$rc."/i",$dnCourant)){
                    $tabDNMatchRecherche[$dnCourant] = 1;
                    $nbEntreeFiltre++;
                }
                
                $dnPartiel='';
                $dnInverse='';
                $nbTabDN = count($tabDN);
                $tailleDNBoucle = 0;
                $bouclePositif=0;
                for($i=($nbTabDN - 1);$i>=0;$i--){
                    if($i > 0){
                        $tailleDNBoucle++;
                        $dnPartiel = $tabDN[$i].$dnPartiel;
                        
                        if($bouclePositif >= 2 && ($rc == '' || ($rc != '' && preg_match("/".$rc."/i",$dnCourant)))){
                            $tabDNFils[$dnPartiel][$dnCourant] = 1;
                        }
                        
                        if($tailleTabDN > 3 && $tailleTabDN == $tailleDNBoucle + 1){
                            $tabDNCompo[$dnPartiel][$dnCourant] = 1;
                            $tabDNCompoReverse[$dnCourant] = $dnPartiel;
                        }
                        $dnPartiel = ','.$dnPartiel;
                    }
                    $dnInverse.=','.$tabDN[$i];
                    $bouclePositif++;
                }
                
                $tabLdapDetail[$dnCourant]['deep'] = $tailleTabDN;
                $tabLdapDetail[$dnCourant]['niveau'] = $tabDN;
                $tabLdapDetail[$dnCourant]['dnInverse'] = $dnInverse;
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
}
uasort($tabLdapDetail,'triLdap');

?>
<table border="1" width="100%" id="affichageResultat" class="table table-bordered table-striped table-condensed">
    <thead>
        <tr class="colorGris">
            <td colspan="<?php echo $nbCase?>">
                <?php
                $nbEntree = count($tabLdapDetail);
                if($nbEntree > 1){
                    print "$nbEntree entr&eacute;es";
                }
                else{
                    print "$nbEntree entr&eacute;e";
                }
                
                if($nbEntreeFiltre > 0){
                    if($nbEntreeFiltre > 1){
                        print " dont $nbEntreeFiltre filtr&eacute;es";
                    }
                    else{
                        print " dont $nbEntreeFiltre filtr&eacute;e";
                    }
                }
                
                ?>
            </td>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td valign="top" width="260">
                <form name="rechercheArbreLdap" method="post" action="index.php" autocomplete="off">
                    <table border="0">
                        <tr>
                            <td>
                                <INPUT type="text" id="rc" name="rc" value="<?php echo $rc?>" class="input-sm form-control" style="width:165px;">
                            </td>
                            <td align="center">
                                <INPUT TYPE="hidden" name="service" VALUE="cldap">
                                <button type="submit" NAME="rechercheArbreLdap" class="btn btn-primary btn-sm"><span class="glyphicon glyphicon-eye-open"></span> Chercher</button>
                            </td>
                        </tr>
                    </table>
                </form>
                <div id="arbreLdap" class="dTree" style="min-height:660px;max-height:660px;overflow-y:auto;">                
                    <ul>
                        <?php
                        affichageArbreLdapRecur($tabLdapDetail,$tabDNCompo,$tabDNFils,$tabDNCompoReverse,'dc=ecole,dc=grenoble,dc=fr',$rc,$tabDNMatchRecherche);
                        ?>
                    </ul>
                </div>
            </td>
            <td valign="top" align="center" style="padding:0px;">
                <div id="detailLdap"></div>
            </td>
        </tr>
    </tbody>
</table>
<?php
}


/*********************************************************************/
/* Fonction permettant d'afficher l'arbre Ldap de manière récurssive */
/*********************************************************************/
function affichageArbreLdapRecur($tabLdapDetail,$tabDNCompo,$tabDNFils,$tabDNCompoReverse,$racine,$rc,$tabDNMatchRecherche){

foreach($tabLdapDetail as $cle => $valeur){
    if($racine == $cle){
        $nbFils = 0;
        // if(isset($tabDNCompo[$cle]) && count($tabDNCompo[$cle]) > 0){
            // $nbFils = count($tabDNCompo[$cle]);
        // }
        
        if(isset($tabDNFils[$cle]) && count($tabDNFils[$cle]) > 0){
            $nbFils = count($tabDNFils[$cle]);
        }

        $classCourante = '';
        if(isset($tabDNCompoReverse[$cle])){
            $classCourante = $tabDNCompoReverse[$cle];
        }
        $cleDebut = preg_replace('/,'.$classCourante.'$/i','',$cle);
    
        if($nbFils > 0){
            if($rc == '' || ($rc != '' && calculAppartenanceDNGroupe($tabDNMatchRecherche,$cle))){
                ?>
                <li>
                    <a href="#" onClick="afficheDetailLdap('<?php echo $cle?>','detailLdap');return false;">
                        <?php echo "$cleDebut ($nbFils)"?>
                    </a>
                    <ul>
                        <?php
                        // Tri des fils par ordre inverse des DN
                        $tabDNCompoInverse = array();
                        foreach($tabDNCompo[$cle] as $cleInterne => $valeurInterne){
                            $tabDNInterne = explode(',',$cleInterne);
                            $dnInverseInterne='';
                            for($i=(count($tabDNInterne) - 1);$i>=0;$i--){
                                $dnInverseInterne.=','.$tabDNInterne[$i];
                            }
                            
                            $tabDNCompoInverse[$dnInverseInterne] = $cleInterne;
                        }
                        
                        ksort($tabDNCompoInverse);
                        foreach($tabDNCompoInverse as $cleInterne => $valeurInterne){
                            affichageArbreLdapRecur($tabLdapDetail,$tabDNCompo,$tabDNFils,$tabDNCompoReverse,$valeurInterne,$rc,$tabDNMatchRecherche);
                        }
                        ?>
                    </ul>
                </li>
                <?php
            }
        }
        else{
            if($rc == '' || ($rc != '' && preg_match("/".$rc."/i",$cle))){
                ?>
                <li>
                    <a href="#" onClick="afficheDetailLdap('<?php echo $cle?>','detailLdap');return false;">
                        <?php echo $cleDebut?>
                    </a>
                </li>
                <?php
            }
        }
    }
}
}


/**********************************************************************************************************/
/* Fonction permettant de savoir si un dn courant est contenu dans une liste de dn contenant la recherche */
/**********************************************************************************************************/
function calculAppartenanceDNGroupe($tabDNMatchRecherche,$cleDNCourant){

$bool=0;
foreach($tabDNMatchRecherche as $cle => $valeur){
    if(preg_match("/".$cleDNCourant."/i",$cle)){
        $bool = 1;
        break;
    }
}

return $bool;
}


/**********************************************************************/
/* Fonction permettant de récupérer toutes les infos à partir d'un DN */
/**********************************************************************/
function getDetailLdap(){

global $ecoleCourant,$colorRouge;
$dn = initialisationVariableFormulaire('dn');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $dn != ''){
    // Récupération des tous les uid pour vérifier que ceux dans les uidMember sont correct
    $tabAllUid = array();
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(objectClass=person)";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $uid = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'uid'));
                
                $tabAllUid[$uid] = 1;
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    // Calcul de quel groupe dépend l'utilisateur courant
    $membreGroupe='';
    if(preg_match("/uid=([^,]+),ou=utilisateurs/",$dn,$uidSearch)){
        $tabDN = array();
        $tabConn = array();
        $memberOf = array();
        $tabDN[] = $ecoleCourant;

        for($d=0;$d<count($tabDN);$d++){
            $tabConn[] = $_SESSION['connLdap'];
        }

        $filter = "(objectClass=posixGroup)";
        $restriction = array();
        $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
        for($e=0;$e<count($sr);$e++){
            $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
            do{
                if($entry != ''){
                    $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                    $memberUid = @ldap_get_values($_SESSION['connLdap'],$entry,'memberUid');
                    
                    foreach($memberUid as $cle => $valeur){
                        if(preg_match("/^[0-9]+$/",$cle) && $uidSearch[1] == $valeur){
                            $memberOf[$cn] = 1;
                        }
                    }
                }                
            }
            while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
        }
        
        ksort($memberOf);
        foreach($memberOf as $cle => $valeur){
            $membreGroupe.="$cle<br>";
        }
    }

    // Création du détail pour le DN courant
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $dn;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $message='<table border="1" width="100%" class="table table-bordered table-striped table-condensed" style="border-top-width: 0px;border-left-width: 0px;"><thead><tr class="colorGris"><td align="center" width="25%">Nom de l\'attribut</td><td align="center" width="75%">Valeur</td></tr></thead><tbody>';
    $filter = "(objectClass=*)";
    $restriction = array();
    $sr = @ldap_read($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $allAttribut = ldap_get_attributes($_SESSION['connLdap'],$entry);
                
                if($membreGroupe != ''){
                    // Ajout du memberOf dans le tableau des attributs
                    $tabData = array();
                    $tabData[] = $membreGroupe;
                    $allAttribut['memberOf'] = $tabData;
                }
                
                // Ajout du DN dans le tableau des attributs
                $tabData = array();
                $tabData[] = @ldap_get_dn($_SESSION['connLdap'],$entry);
                $allAttribut['dn'] = $tabData;
                
                ksort($allAttribut);
                foreach($allAttribut as $cle => $valeur){
                    if(!preg_match("/^[0-9]+$/i",$cle) && $cle != 'count'){
                        $message.="<tr><td align=\"left\">$cle</td><td align=\"left\">";
                        asort($valeur);
                        foreach($valeur as $cle1 => $val1){
                            if(preg_match("/^[0-9]+$/i",$cle1)){
                                $message.="$val1";
                                if($cle == 'memberUid' && !isset($tabAllUid[$val1])){
                                    $message.='<span style="color:'.$colorRouge.'"> (Erreur)</span>';
                                }
                                $message.="<br>";
                            }
                        }
                        $message = preg_replace('/<br>$/i','',$message);
                        $message.="</td></tr> ";
                    }
                }
            }                
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }
    
    $message.="</tbody></table>";
    print $message;
}
}


/*****************************************************/
/* Fonction permettant d'afficher des bulles d'aide  */
/*****************************************************/
function calculBullAide($titre,$messageAide){

$messageAide = calculCommentaireBullInfoClient($messageAide);
?>
<table border="0" style="border:0px;padding:0px;margin:0px;">
    <tr>
        <td style="padding:0px;padding-left:10px;">
            <a href="#" <?php echo $messageAide?>>
                <img src="/image/aide.png" border="0" width="20" height="20">
            </a>
        </td>
        <td class="tdNoPadding">
            <?php echo $titre?>
        </td>
    </tr>
</table>
<?php
}


/**********************************************************************************************/
/** Fonction permettant de calculer le contenu d'une bull d'aide sur les commentaires client  */
/**********************************************************************************************/
function calculCommentaireBullInfoClient($commentaireClient){

$maxLigneCommentaire = 100;   
$commentaireClientBull='';
if($commentaireClient != ''){
    $verifTailleCommentaire = explode('/[\n]/',$commentaireClient);
    if(count($verifTailleCommentaire) > $maxLigneCommentaire){
        $commentaireClient='';
        for($com=0;$com<$maxLigneCommentaire;$com++){
            $commentaireClient.=$verifTailleCommentaire[$com]."\n";
        }
        $commentaireClient.='...';
    }
    
    $commentaireClient = preg_replace('/\'/i','###',$commentaireClient);
    $commentaireClient = preg_replace('/^[\n\r]+/i','',$commentaireClient);
    $commentaireClient = preg_replace('/[\n\r]+$/i','',$commentaireClient);
    $commentaireClient = preg_replace('/[\n\r]+/i','<br>',$commentaireClient);
    $commentaireClient = preg_replace('/"/i','%%%',$commentaireClient);

    $commentaireClientBull="onMouseOver=\"AffBulle('$commentaireClient','300','20','-30','0');\" onMouseOut=\"HideBulle();\"";
}

return $commentaireClientBull;
}


/*******************************************************/
/** Fonction permettant de supprimer un administrateur */
/*******************************************************/
function suppressionCompteAdminProxyAction($commentaireClient){

global $ecoleCourant;
$dn = initialisationVariableFormulaire('dn');
$type = initialisationVariableFormulaire('type');
$uid = initialisationVariableFormulaire('uid');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && $dn != '' && $type != '' && $uid != ''){
    // Suppression du compte
    @ldap_delete($_SESSION['connLdap'],$dn);
    
    $groupe='';
    if($type == 0){
        $groupe='proxi';
    }
    else{
        $groupe='internet';
    }
    
    $tabMember = array();
    $tabMember['memberUid'] = $uid;

    @ldap_mod_del($_SESSION['connLdap'],"cn=$groupe,ou=groupes,$ecoleCourant",$tabMember);
}
}


/**************************************************************/
/** Fonction permettant de chiffrer un mot de passe avec SSHA */
/**************************************************************/
function chiffrementPassword($motPasse){

$salt = substr(str_shuffle(str_repeat('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789',4)),0,4);
$motPasse = '{SSHA}'.base64_encode(sha1($motPasse.$salt,TRUE).$salt);

return $motPasse;
}


/***************************************************************************************/
/** Fonction permettant de vérifier la validité d'un mot de passe avec un hash en Ldap */
/***************************************************************************************/
function verificationMotPasseLdap($password,$hash){

$bool=0;

if($hash{0} != '{'){
    if($password == $hash){
        $bool = 1;
    }
}
elseif(substr($hash,0,7) == '{crypt}'){
    if(crypt($password, substr($hash,7)) == substr($hash,7)){
        $bool = 1;
    }
}
elseif(substr($hash,0,5) == '{MD5}'){
    $encrypted_password = '{MD5}'.base64_encode(md5($password,true));
}
elseif(substr($hash,0,6) == '{SHA1}'){
    $encrypted_password = '{SHA}'.base64_encode(sha1($password,true));
}
elseif(substr($hash,0,6) == '{SSHA}'){
    $salt = substr(base64_decode(substr($hash,6)),20);
    $encrypted_password = '{SSHA}'.base64_encode(sha1($password.$salt,true).$salt);
}

if($hash == $encrypted_password){
    $bool = 1;
}

return $bool;
}


/******************************************************************************/
/* Fonction permettant d'afficher le détail des directeurs pour les destituer */
/******************************************************************************/
function affichageDestitutionDirecteur($tabInfo,$idTableau,$host,$affectationUtilisateur,$tabEcole){

?>
    <tr class="colorGris">
        <td align="center">
            Nom
        </td>
        <td align="center">
            Pr&eacute;nom
        </td>
        <td align="center">
            Identifiant
        </td>
        <?php
        if($host == 9999){
            ?>
            <td align="center">
                Affectation
            </td>
            <?php
        }
        ?>
        <td align="center">
            R&eacute;trograder
        </td>
    </tr>
</thead>
<tbody>
<?php

foreach($tabInfo as $cle => $valeur){
    ?>
    <tr>
        <td width="20%">
            <?php echo $valeur['sn']?>
        </td>
        <td width="20%">
            <?php echo $valeur['givenName']?>
        </td>
        <td width="20%">
            <?php echo $valeur['uid']?>
        </td>
        <?php
        if($host == 9999){
            ?>
            <td width="20%">
                <?php
                if(isset($affectationUtilisateur[$valeur['uid']]) && isset($tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'])){
                    print $tabEcole[$affectationUtilisateur[$valeur['uid']]]['nom'];
                }
                else{
                    print "Affectation Inconnue";
                }
                ?>
            </td>
            <?php
        }
        ?>
        <td align="center" width="20%">
            <button type="submit" NAME="destituerDirecteur" class="btn btn-primary btn-sm" onClick="destituerDirecteur('<?php echo $valeur['uid']?>',this,'<?php echo $idTableau?>');return false;">R&eacute;trograder</button>
        </td>
    </tr>
<?php
}
}


/*************************************************/
/* Fonction permettant de destituer un directeur */
/*************************************************/
function destitutionDirecteurAction(){

global $ecoleCourant;
$uid = initialisationVariableFormulaire('uid');

if(isset($_SESSION['connLdap']) && $_SESSION['connLdap'] != '' && isset($_SESSION['ldapbind']) && $_SESSION['ldapbind'] != '' && $uid != ''){
    $tabMember = array();
    $tabMember['memberUid'] = $uid;
    // Recherche du groupe à l'école l'enseignant appartient
    
    $tabDN = array();
    $tabConn = array();
    $tabDN[] = $ecoleCourant;

    for($d=0;$d<count($tabDN);$d++){
        $tabConn[] = $_SESSION['connLdap'];
    }

    $filter = "(&(objectClass=posixGroup)(memberUid=$uid))";
    $restriction = array();
    $sr = @ldap_search($tabConn,$tabDN,$filter,$restriction);
    for($e=0;$e<count($sr);$e++){
        $entry = @ldap_first_entry($_SESSION['connLdap'],$sr[$e]);
        do{
            if($entry != ''){
                $cn = getInfoLdapEntry(@ldap_get_values($_SESSION['connLdap'],$entry,'cn'));
                $cnFormalise = preg_replace('/-d$/','',$cn);
                
                if(preg_match("/-d$/",$cn)){
                    @ldap_mod_del($_SESSION['connLdap'],"cn=$cnFormalise-d,ou=groupes,$ecoleCourant",$tabMember);
                }
            }
        }
        while($entry = @ldap_next_entry($_SESSION['connLdap'],$entry));
    }

    // Suppression du compte de superutilisateur
    @ldap_delete($_SESSION['connLdap'],"cn=$uid,ou=sudoers,$ecoleCourant");
    
    // Suppression de cet utilisateur du groupe des directeurs globaux
    @ldap_mod_del($_SESSION['connLdap'],"cn=direction,ou=groupes,$ecoleCourant",$tabMember);
}
}


/*************************************************/
/* Fonction permettant de destituer un directeur */
/*************************************************/
function zoneSelectionEcoleForm($host,$service,$rc){

$tabEcole = listeEcole();
$tabEcoleActive = listeEcoleActiveLdap();

// Si un proxi ou un admin se connecte il doit choisir une école au préalable
?>
<form name="selectionEcole" method="post" action="index.php" autocomplete="off">
    <table border="0">
        <tr>
            <?php
            if($_SESSION['estUtilisateur'] == 3 || $_SESSION['estUtilisateur'] == 4){
                $checkAll='';
                if($host == 9999){
                    $checkAll = 'selected';
                }
            ?>
            <td>
                <select name="host" id="host" class="hauteurSelect" class="form-control input-sm">
                    <option value=''>Choix d'une &eacute;cole</option>
                    <option value='9999' <?php echo $checkAll?>>Toute les &eacute;coles</option>
                    <?php
                    foreach($tabEcoleActive as $cleTabEcole => $valeurTabEcole){
                        $check='';
                        if($host == $cleTabEcole){
                            $check = 'selected';
                        }
                        ?>
                        <option value='<?php echo $cleTabEcole?>' <?php echo $check?>><?php echo $tabEcole[$cleTabEcole]['nom']?></option>
                        <?php
                    }
                    ?>
                </select>
            </td>
            <?php
            }
            ?>
            <td>
                <INPUT type="text" id="rc" name="rc" value="<?php echo $rc?>" class="input-sm form-control" size="40">
            </td>
            <td align="center">
                <INPUT TYPE="hidden" name="service" VALUE="<?php echo $service?>">
                <button type="submit" NAME="selectionEcole" class="btn btn-primary btn-sm"><span class="glyphicon glyphicon-eye-open"></span> Chercher</button>
            </td>
        </tr>
    </table>
</form><br>
<?php

return $tabEcole;
}


/*******************************************************************************************/
/* Fonction permettant d'afficher des informations sur la page d'accueil une fois connecté */
/*******************************************************************************************/
function affichagePageConnecte(){

$host = calculHostCourant();
$tabEcole = listeEcole();

$displayName='';
if(isset($_SESSION['cn'])){
    $displayName = $_SESSION['cn'];
}

$nomEcoleCourante='';
if(isset($tabEcole[$host])){
    $nomEcoleCourante = ' (Ecole '.$tabEcole[$host]['nom'].')';
}

?>
<table border="0">
    <tr>
        <td>
            <br><h4>Bienvenue dans votre espace de gestion <b><?echo $displayName?></b><?php echo $nomEcoleCourante?></h4>
        </td>
    </tr>
<table>
<?php
}


/***********************************************************************************/
/* Fonction permettant d'afficher un tableau HTML de manière paginé avec BootStrap */
/***********************************************************************************/
function paginationTableau($idTab,$tailleTab){

global $nbMaxLigneTab;

if($tailleTab > 0){
    ?>
    <script type="text/javascript">
        <!--
        $(document).ready(function() {
            $('<?php echo $idTab?>').dataTable({
                "lengthMenu": [[<?php echo $nbMaxLigneTab?>],[<?php echo $nbMaxLigneTab?>]],
                <?php
                if($tailleTab >= $nbMaxLigneTab){
                    ?>
                    "dom": '<"toolbar">rtp',
                    <?php
                }
                else{
                    ?>
                    "dom": '<"toolbar">rt',
                    <?php
                }
                ?>
            });
        } );
        -->
    </script>
    <?php
}
}


/********************************************************************/
/* Fonction permettant d'afficher les infos du head de la page HTML */
/********************************************************************/
function initialisationHead($service,$rc,$loginAdmin,$passwordAdmin){

?>
<title>
    Gestion des Écoles
</title>
<meta charset="utf-8">
<meta http-equiv="Content-Language" content="fr">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<!--<link rel="stylesheet" href="css/ville.css" type="text/css">-->
<link rel="stylesheet" href="bootstrap/css/bootstrap.min.css" type="text/css">
<link rel="stylesheet" href="bootstrap/css/dataTables.bootstrap.css" type="text/css">
<link rel="stylesheet" href="css/ecole.css" type="text/css">

<?php
if($service == 'cldap'){
    ?>
    <link rel="stylesheet" href="tree/css/dtree.css" type="text/css">
    <?php
}
?>

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="bootstrap/js/jquery.dataTables.min.js"></script>
<script type="text/javascript" src="bootstrap/js/dataTables.bootstrap.js"></script>
<?php
if($service == 'cldap'){
    ?>
    <script type="text/javascript" src="tree/js/dtree.js"></script>
    <?php
}
?>
<script type="text/javascript" src="js/ecole.js"></script>
<script type="text/javascript">
    <!--
    <?php
    if($service == 'cldap'){
        ?>
        $(document).ready(function(){
            $(".dTree").dTree({
                closeSameLevel: false, // close same level nodes
                useCookie: false, // enable cookie support
                
                <?php
                if($rc != ''){
                    ?>
                    openAllFolder: true,
                    <?php
                }
                ?>
            });
        });
        <?php
    }
    ?>
    
    $(function () {
      $('[data-toggle="tooltip"]').tooltip()
    })
    
    window.onload =
    function(){
        autoCompleteMode('login');
        autoCompleteMode('loginAccueil');
        autoCompleteMode('password');
        autoCompleteMode('passwordAccueil');
        vidageChamp('changementPassword');
        vidageChamp('confirmationChangementPassword');
        
        // Récupération dynamique du nom de domaine pour la passé au javascript
        baseURL = '<?php echo 'http://'.$_SERVER['HTTP_HOST'].'/'?>';

        <?php
        if($loginAdmin == ''){
            ?>
            vidageChamp('loginAdmin');
            <?php
        }
        
        if($passwordAdmin == ''){
            ?>
            vidageChamp('passwordAdmin');
            <?php
        }
        ?>
    };
    
    var tabAutoCompletion = new Array();
    var indiceAutoCompletionGlobal=0;
    var tailleTabAutocompletion=0;
    var firstDeplacementClavier=1;
    var estBoxAutoCompletionActive=0;
    var posX=0;posY=0;
    var xOffset=10;yOffset=10;
    var afficheBulle=false;
    var nomBulle='bulleAide';
    var decallageBulleX=0;
    var decallageBulleY=0;
    var estAffichageStructure=0;
    var estSIGValide=1;
    document.onmousemove=move;
    //-->
</script>
<?php
}


/*****************************************************/
/* Fonction permettant d'afficher le bandeau du site */
/*****************************************************/
function affichageBandeau(){

?>
<a href="index.php" style="text-decoration:none;">
    <div style="padding-top:80px;">
        <div style="position:absolute;top:0px;height:60px;width:225px;background-image: url('./image/logo.png');margin: 0px;padding: 0px;"></div>
        <div style="position:absolute;top:0px;float:left;left:50%;margin-left:-158px;font-weight:900;font-size:40px;color:#000000;">Gestion des Écoles</div>
    </div>
</a>
<div id="bulleAide" style="text-align:left;position:absolute;visibility:hidden;border:1px solid Black;padding:8px;border-radius:5px;font-family:navy,Arial;font-size:12px;background-color:#FFFFFF;color:#000000;"></div>
<?php
}

